;===========================================================================================================================================================================;
;===========================================================================================================================================================================;
;==================================                                                                                                       ==================================;
;==================================    _____                       ____  _   _                    _____       _______  ____               ==================================;
;==================================   / ____)                     / ___)(_)_| |_        __       (_   _)     /  _____)|  _ \              ==================================;
;==================================  | |      __ _ ___  ___      | |     _(_   _)_   _ /_/___      | |      _| |_ ___ | (_) ) ___ __  __  ==================================;
;==================================  | |     / _` | _ \/ _ \ ___ | |    | | | | | \ / |  / __)     | |  _ _(_  __/ _ \|  _  \/ _ \\ \/ /  ==================================;
;==================================  | |____| (_| |(_| | __/|___|| |___ | | | | | |_| |  \__ \    _| |_| `  || | |(_)|| (_) )|(_)|| | |   ==================================;
;==================================   \_____)\__,_| __/\___)     \_____)|_| \_\ \___  |  (___/   (_____)_||_||_| \___/|____/ \___/__/\_\  ==================================;
;==================================   ____________| |______________________________/ /                                                    ==================================;
;==================================  (____________|_|_______________________________/                                                     ==================================;
;==================================                                                                                                       ==================================;
;===========================================================================================================================================================================;
;===========================================================================================================================================================================;

;
; Ungarische Notation (weitestgehend): $aX = Array, $cX = Counter, $hX = Handle, $iX = Integer, $pX = Pointer, $sX = String, ..., $ah_X = Array/Handle
;
; ER_CPS = EffectsRotate, FW_CPS = FontWobbler, TS_CPS = TextSlider, SW_CPS = StarWarsScroller, SI_CPS = StarWarsImageMove, VM_CPS = VUMeterShufflePlayPause
;

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _InfoBox
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _InfoBox()																																	; Funktionsstart: _InfoBox

	Opt ("GUIOnEventMode", 1)																													; OnEvent Aktionen in der GUI erlauben

	; ##############################################################################################################################
	; Main Value Globals and Locals ################################################################################################
	Global Const $iGUI_Width = 800, $iGUI_Height = 710, $iScrollerXPos = 100																	; Globale Variablen initialisieren
	Global Const $iImageGUI_Width = 256, $iImageGUI_Height = 256, $iImageYPos = 260																; Globale Variablen initialisieren
	Global Const $iSW_ImagesMax = 9, $iBG_StarWarsMax = 5, $iBG_NormalMax = 6, $iSW_ScrollSpeed = 3.2											; Globale Variablen initialisieren: Anzahl Bilder
	Global $iCT_SongsMax = 9																													; Globale Variablen initialisieren: Anzahl Songs
	Local Const $iDO_SleepWait = 30, $iDO_ScrollPosStep = 4																						; Lokale Variablen initialisieren
	; ##############################################################################################################################
	; Debug Value Globals #########ä################################################################################################
	Global $iDebugTimer = False																													; Globale Variablen initialisieren
	; ##############################################################################################################################
	; ##############################################################################################################################

	Global $iTextSlider = False, $iColorDefault = False, $iLen = $iGUI_Width / 10																; Globale Variablen initialisieren
	Global $iInfoBoxExitButton = False, $hMessage[4], $sHiddenScreenCode = False, $iDO_LoopCounter = 0											; Globale Variablen initialisieren
	Global $TogglePlay, $ToggleEffekt, $aAppStatus[3]																							; Globale Variablen initialisieren
	Global $aMoveGUIPos[5], $hScrollLabel, $xFontNew = False, $aLabelHeight[10], $aLabelYPos[10]												; Globale Variablen initialisieren
	Global $iShowCPS = 0, $iCpsTimer, $aER_CPS[2], $aFW_CPS[2], $aTS_CPS[2], $aSW_CPS[2], $aSI_CPS[2], $aVM_CPS[2]								; Globale Variablen initialisieren

	Local $iDO_ScrollPos = 0, $sCW_Text																											; Lokale Variablen initialisieren

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Star Wars Gifs
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $ah_SW_ImageFile[$iSW_ImagesMax + 1], $iSW_Image = Random (1, $iSW_ImagesMax, 1), $iSW_Enable = False								; Globale Variablen initialisieren und definieren
	Global $aSW_XPosDelay[5], $iSW_ForceModify = 1, $iSW_ForceMode = False, $iSW_ImageActual, $iSW_ChooseImage = False							; Globale Variablen initialisieren und definieren

	$aSW_XPosDelay[1] = 15																														; Variable definieren: Star Wars Image-GUI Schrittweite
	$aSW_XPosDelay[2] = 120																														; Variable definieren: Ab welcher Schrittweite soll die Image-GUI verzögert werden?
	$aSW_XPosDelay[3] = $aSW_XPosDelay[2] + $aSW_XPosDelay[1]																					; Variable definieren: Ab welcher Schrittweite soll die Image-GUI verzögert werden?
	$aSW_XPosDelay[4] = $aSW_XPosDelay[1] / 2																									; Variable definieren: Star Wars Image-GUI Schrittweiteverzögerung

	$ah_SW_ImageFile[1] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile1(), True)										; Variable definieren: StarWars_ImageFile from Memory: 1 = StarWars_VaderStill
	$ah_SW_ImageFile[2] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile2(), True)										; Variable definieren: StarWars_ImageFile from Memory: 2 = StarWars_VaderMove
	$ah_SW_ImageFile[3] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile3(), True)										; Variable definieren: StarWars_ImageFile from Memory: 3 = StarWars_R2D2Still
	$ah_SW_ImageFile[4] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile4(), True)										; Variable definieren: StarWars_ImageFile from Memory: 4 = StarWars_YodaMove
	$ah_SW_ImageFile[5] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile5(), True)										; Variable definieren: StarWars_ImageFile from Memory: 5 = StarWars_DeathStar
	$ah_SW_ImageFile[6] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile6(), True)										; Variable definieren: StarWars_ImageFile from Memory: 6 = StarWars_AhsokaTanoMove
	$ah_SW_ImageFile[7] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile7(), True)										; Variable definieren: StarWars_ImageFile from Memory: 4 = StarWars_MilleniumFalcon
	$ah_SW_ImageFile[8] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile8(), True)										; Variable definieren: StarWars_ImageFile from Memory: 5 = StarWars_GeneralGrievousMove
	$ah_SW_ImageFile[9] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_StarWars_ImageFile9(), True)										; Variable definieren: StarWars_ImageFile from Memory: 6 = StarWars_X-Wing

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Chip-Music (mit der Möglichkeit die Lieder durch eine Chip Music Datei zu ersetzen)
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $ah_ChipMusicMEM[$iCT_SongsMax + 1 + 10]																								; Globales Variablen-Array initialisieren

	Local $sCM_FileName1 = "ChipMusicMain.dat"																									; Varibale initialisieren und definieren

	If FileExists (@ScriptDir & "\" & $sCM_FileName1) Then																						; If-Abfrage: Existiert die Datei $sCM_FileName1?

		SplashTextOn("Loading...", "The Main Chip Musicfile -> " & $sCM_FileName1 & " <- is loading!" & @CRLF & "Please wait...", 450, 60)		; SplashText ausgeben

		For $iCM = 1 To 9																														; ForNext-Schleife

			$ah_ChipMusicMEM[$iCM] = _Chip_Music_INI ($sCM_FileName1, "Chip_Music", $iCM)														; Variable definieren: Chip_Music from INI-File

		Next																																	; Ende der ForNext-Schleife

		SplashOff()																																; SplashText löschen

	EndIf																																		; Ende der If-Abfrage: Existiert die Datei $sCM_FileName1?

	$ah_ChipMusicMEM[0] = _Chip_Music0()																										; Variable definieren: Chip_Music from Memory: 0 = Star_Wars_Intro

	If $ah_ChipMusicMEM[1] = "Error" Or $ah_ChipMusicMEM[1] = "" Then $ah_ChipMusicMEM[1] = _Chip_Music1()										; Variable definieren: Chip_Music from Memory: 1 = A_Fox_In_My_Box
	If $ah_ChipMusicMEM[2] = "Error" Or $ah_ChipMusicMEM[2] = "" Then $ah_ChipMusicMEM[2] = _Chip_Music2()										; Variable definieren: Chip_Music from Memory: 2 = C64_Loop_Song
	If $ah_ChipMusicMEM[3] = "Error" Or $ah_ChipMusicMEM[3] = "" Then $ah_ChipMusicMEM[3] = _Chip_Music3()										; Variable definieren: Chip_Music from Memory: 3 = Stupid_Bird
	If $ah_ChipMusicMEM[4] = "Error" Or $ah_ChipMusicMEM[4] = "" Then $ah_ChipMusicMEM[4] = _Chip_Music4()										; Variable definieren: Chip_Music from Memory: 4 = C64_Song
	If $ah_ChipMusicMEM[5] = "Error" Or $ah_ChipMusicMEM[5] = "" Then $ah_ChipMusicMEM[5] = _Chip_Music5()										; Variable definieren: Chip_Music from Memory: 5 = R-Type
	If $ah_ChipMusicMEM[6] = "Error" Or $ah_ChipMusicMEM[6] = "" Then $ah_ChipMusicMEM[6] = _Chip_Music6()										; Variable definieren: Chip_Music from Memory: 6 = Turrican II Remix
	If $ah_ChipMusicMEM[7] = "Error" Or $ah_ChipMusicMEM[7] = "" Then $ah_ChipMusicMEM[7] = _Chip_Music7()										; Variable definieren: Chip_Music from Memory: 7 = Turrican III
	If $ah_ChipMusicMEM[8] = "Error" Or $ah_ChipMusicMEM[8] = "" Then $ah_ChipMusicMEM[8] = _Chip_Music8()										; Variable definieren: Chip_Music from Memory: 8 = Blood Money
	If $ah_ChipMusicMEM[9] = "Error" Or $ah_ChipMusicMEM[9] = "" Then $ah_ChipMusicMEM[9] = _Chip_Music9()										; Variable definieren: Chip_Music from Memory: 9 = Giana Sisters

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Ist eine Extra Chip Music Datei vorhanden? Diese bietet die Möglichkeit jeweils um 10 (Num 0 - 9) Lieder zu erweitern
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Local $sCM_FileName2 = "ChipMusicXtra.dat"																									; Varibale initialisieren und definieren

	If FileExists (@ScriptDir & "\" & $sCM_FileName2) Then																						; If-Abfrage: Existiert die Datei $sCM_FileName2?

		SplashTextOn("Loading...", "The X-tra Chip Musicfile -> " & $sCM_FileName2 & " <- is loading!" & @CRLF & "Please wait...", 450, 60)		; SplashText ausgeben

		For $iCM = 0 To 9																														; ForNext-Schleife
			
			$ah_ChipMusicMEM[$iCM + 10] = _Chip_Music_INI ($sCM_FileName2, "Chip_Music", $iCM)													; Variable definieren: Chip_Music from INI-File
			If $ah_ChipMusicMEM[$iCM + 10] <> "Error" Or $ah_ChipMusicMEM[$iCM + 10] <> "" Then $iCT_SongsMax += 1								; If-Abfrage: SongsMax erhöhen, wenn kein Fehler

;~ 			$sCW_Text = "CT_SongsMax: " & $iCT_SongsMax																							; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Next																																	; Ende der ForNext-Schleife

		SplashOff()																																; SplashText löschen

	Else																																		; Else-Abfrage: Existiert die Datei $sCM_FileName2?

		For $iCM = 0 To 9																														; ForNext-Schleife

			$ah_ChipMusicMEM[$iCM + 10] = "Error"																								; Variable definieren: Chip_Music auf Error setzen

		Next																																	; Ende der ForNext-Schleife

	EndIf																																		; Ende der If-Abfrage: Existiert die Datei $sCM_FileName2?

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Hintergründe
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $ah_ScrollLabel[$iBG_NormalMax + 1], $iBG_NormalNr = Random (1, $iBG_NormalMax, 1), $iBG_NormalActual = $iBG_NormalNr				; Globale Variablen initialisieren und definieren
	$ah_ScrollLabel[1] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage1(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)
	$ah_ScrollLabel[2] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage2(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)
	$ah_ScrollLabel[3] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage3(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)
	$ah_ScrollLabel[4] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage4(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)
	$ah_ScrollLabel[5] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage5(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)
	$ah_ScrollLabel[6] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_NormalImage6(), True, $iGUI_Width, $iGUI_Height)					; Variable definieren: BackgroundImageFile from Memory (Normaler Modus)

	Global $ah_BG_StarWarsFile[$iBG_StarWarsMax + 1], $iBG_StarWarsNr = Random (1, $iBG_StarWarsMax, 1), $iBG_StarWarsActual = $iBG_StarWarsNr	; Globale Variablen initialisieren und definieren
	$ah_BG_StarWarsFile[1] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_StarWarsImage1(), True, $iGUI_Width, $iGUI_Height)			; Variable definieren: BackgroundImageFile from Memory (Star Wars Modus)
	$ah_BG_StarWarsFile[2] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_StarWarsImage2(), True, $iGUI_Width, $iGUI_Height)			; Variable definieren: BackgroundImageFile from Memory (Star Wars Modus)
	$ah_BG_StarWarsFile[3] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_StarWarsImage3(), True, $iGUI_Width, $iGUI_Height)			; Variable definieren: BackgroundImageFile from Memory (Star Wars Modus)
	$ah_BG_StarWarsFile[4] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_StarWarsImage4(), True, $iGUI_Width, $iGUI_Height)			; Variable definieren: BackgroundImageFile from Memory (Star Wars Modus)
	$ah_BG_StarWarsFile[5] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_BG_StarWarsImage5(), True, $iGUI_Width, $iGUI_Height)			; Variable definieren: BackgroundImageFile from Memory (Star Wars Modus)

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Tower-Gifs
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $ah_Tower_ImageFile[3]																												; Globales Variablen-Array initialisieren
	$ah_Tower_ImageFile[1] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_Tower_ImageFile1(), True)										; Variable definieren: Turm_ImageFile from Memory: 1 = Turm_links
	$ah_Tower_ImageFile[2] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_Tower_ImageFile2(), True)										; Variable definieren: Turm_ImageFile from Memory: 2 = Turm_rechts

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Exit-Gifs
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $ah_Exit_ImageFile[2]																												; Globales Variablen-Array initialisieren
	Local $iExitWidth = 120, $iExitHeight = 45, $iExitSpace = 10, $iExitPosVUMWidth = ($iGUI_Width - $iExitWidth) / 2							; Variable definieren: Breite der Labels

	$ah_Exit_ImageFile[1] = _GDIPlus_PrivateBitmapCreateFromMemoryWithResize (_Exit_ImageFile1(), True, $iExitWidth - $iExitSpace, $iExitHeight); Variable definieren: Exit_ImageFile from Memory: 1 = Exit

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	GUICtrlDelete ($hInfoButton)																												; Info Button in Main GUI löschen
	If (@OSVersion = "WIN_10") Then $hInfoButtonJoke = GUICtrlCreateLabel (ChrW(9786), 380, -3, 25, 25)											; If-Abfrage: Bei Win 10 Joke Button in Main GUI setzen
	If (@OSVersion = "WIN_10") Then GUICtrlSetFont ($hInfoButtonJoke, 15)																		; If-Abfrage: Bei Win 10 Joke Buttonfont in Main GUI setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Texte für die GUIs
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $sHeadlineText, $sScrollText, $sSW_ScrollText, $sFontFormerText, $sForceText															; Globale Variablen initialisieren
	Local $iMemory = MemGetStats()																												; Lokale Variable initialisieren: RAM Größe ermitteln

	$sHeadlineText = "Cape-City proudly presents:"																								; Variable definieren: Mit Daten füllen

	$sScrollText = $sApplication_Name																											; Variable definieren: Mit Daten füllen

	$sSW_ScrollText &= "S T A R   W A R S   M O D E                                                                        "					; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Hi everybody, i'm glad to present to you my very first little Graphic & Sound Demo, mostly written in AutoIt. At "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "the beginning, this part of code was supposed to only be a simple InfoBox for my future programs. Step by step "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "more code was coming into it and this is the result. I'm still a big fan of the HomeComputer age and the demon"			; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "stration programs at that time, which showed what the machines really could do. I loved my Atari 1040STFM above "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "everything, with all the Demos and Intros. I had to read all text of every scroller within them, so i felt being a "	; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "part of the scene. Coding these things wasn't something I was able to, but now with AutoIt and many years of IT "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Experience i'm able to do such things too. Sometime with help, but mostly by myself."									; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "So now sit back, relax and enjoy this piece of code! Have fun and a great day, bye bye for now!"						; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Hint: In normal mode press the keys 1 - 9 to change the music, in the Star Wars mode press the keys F1 to F9 to "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "change the image and when the image moves, press the + or - key for more   #+-  J E D I    F O R C E  -+#"				; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Did you already found the Hidden Scroller?                YES, you did - YIPPIEH!   You're reading it right now..."		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "... but did you already found the Hidden Screen?          NO? It's still there!"										; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Did you know, that you can play more music with an extra '" & $sCM_FileName2 & "' file?                   WAAHOOOO!"	; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Did you know, that you can also replace the main music with an '" & $sCM_FileName1 & "' file?            EXCELLENT!"	; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "                                                                                                                  "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Hint: Press the Spacebar to switch the effects On or Off, press the Enter Key to turn the Star Wars mode On or "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Off, press the Left or Right Arrow Key to change the background image and in normal mode press the Hash Key to "		; Variable definieren: Mit Daten füllen
	$sSW_ScrollText &= "Start or Pause the music.                                     "															; Variable definieren: Mit Daten füllen

	$sFontFormerText &= @CRLF & $sApplication_Version &  " - Copyright " & $sApplication_Copyright & @CRLF										; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Compiled with AutoIt Version: " & @AutoItVersion & @CRLF	& @CRLF														; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "For further questions send me an e-mail to CAPE-CITY@GMX.DE" & @CRLF													; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "or visit me at the german AutoIt forum" & @CRLF																		; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "https://autoit.de/index.php/User/215304-Cape-City/#about" & @CRLF & @CRLF												; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Have fun with my little program ;)" & @CRLF & @CRLF																	; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Current operation system: Windows " & StringTrimLeft(@OSVersion, 4) & " - "											; Variable definieren: Mit Daten füllen
	$sFontFormerText &= @OSServicePack & " - Build " & @OSBuild & @CRLF																			; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Resolution: " & @DesktopWidth & "*" & @DesktopHeight & " Pixel - " & "Colordepth: "									; Variable definieren: Mit Daten füllen
	$sFontFormerText &= @DesktopDepth & " Bit - " & "Refreshrate: " & @DesktopRefresh & " Hz" & @CRLF											; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Domain\\Server : " & @LogonDomain & @LogonServer & " - Username : " & @UserName & @CRLF								; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Hostname : " & @ComputerName & " - Memory: " & Int($iMemory[2] / 1024) & " / " & Int($iMemory[1] / 1024)				; Variable definieren: Mit Daten füllen
	$sFontFormerText &= " MByte RAM free" & @CRLF	& @CRLF																						; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "The copyright for all the used songs, images and UDFs belongs to their owner!" & @CRLF & @CRLF							; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Special thanks goes to:" & @CRLF																						; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "User UEZ, Prog@ndy, eukalyptus and to all other user I forgot." & @CRLF												; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "Further to 'www.modarchive.org' for the great chip music," & @CRLF														; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "to 'www.dafont.com' for the nice TTF fonts" & @CRLF																	; Variable definieren: Mit Daten füllen
	$sFontFormerText &= "and to 'www.iconarchive.com' for the lovely icons and images!" & @CRLF													; Variable definieren: Mit Daten füllen

	$sForceText = "|||||MaY |THE\ |FoVc; |B; WiTH\ |y|ou|||||"																					; Variable definieren: Mit Daten füllen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Info-GUI mit den Platzhalter Elementen
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Local $iArray = 1																															; Lokale Variable initialisieren

	; Info-GUI #####################################################################################################################
	Global Const $hInfoFormGUI = GUICreate ("The info behind the pi", $iGUI_Width, $iGUI_Height, -1, -1)										; GUI erstellen
	GUISetOnEvent($GUI_EVENT_CLOSE, "_GUI_GetMsg")																								; GuiSetOnEvent: $GUI_EVENT_CLOSE
	GUISetOnEvent($GUI_EVENT_MINIMIZE, "_GUI_GetMsg")																							; GuiSetOnEvent: $GUI_EVENT_MINIMIZE
    GUISetOnEvent($GUI_EVENT_RESTORE, "_GUI_GetMsg")																							; GuiSetOnEvent: $GUI_EVENT_RESTORE
	GUISetIcon ($sApplication_IconFile)																											; Icon in der GUI setzen
	Global Const $hBackground = GUICtrlCreatePic ("", 0, 0, $iGUI_Width, $iGUI_Height)															; Bild auf GUI Größe erstellen
	GUICtrlSetState ($hBackground, $GUI_DISABLE)																								; Bild in den Hintergrund packen
	GUICtrlSendMsg($hBackground, $STM_SETIMAGE, 0, $ah_ScrollLabel[$iBG_NormalNr])																; Hintergrundbild laden
	; ##############################################################################################################################

	; Headline-GUI innerhalb der Info-GUI ##########################################################################################
	$aLabelHeight[$iArray] = 100																												; Variablen-Array definieren: LabelHeight Array #1
	$aLabelYPos[$iArray] = 10																													; Variable definieren: LabelYPos Array #1
	Global Const $iHeadline = $iArray																											; Variable definieren: Array Zeiger in $iHeadline übernehmen
	; ##############################################################################################################################

	; Scroller-GUI innerhalb der Info-GUI ##########################################################################################
	$aLabelYPos[$iArray + 1] = $aLabelYPos[$iArray] + $aLabelHeight[$iArray]																	; Variable definieren: LabelYPos um LabelHeight in Array #1 erhöhen
	$iArray += 1																																; Variable definieren: Array Zeiger um 1 erhöhen
	$aLabelHeight[$iArray] = 40																													; Variablen-Array definieren: LabelHeight Array #2
	Global Const $iScroller = $iArray																											; Variable definieren: Array Zeiger in $iScroller übernehmen
	; ##############################################################################################################################

	; FontFormer-GUI innerhalb der Info-GUI ########################################################################################
	$aLabelYPos[$iArray + 1] = $aLabelYPos[$iArray] + $aLabelHeight[$iArray] 																	; Variable definieren: LabelYPos um LabelHeight in Array #2 erhöhen
	$iArray += 1 																																; Variable definieren: Array Zeiger um 1 erhöhen
	$aLabelHeight[$iArray] = 430 																												; Variablen-Array definieren: LabelHeight Array #3
	Global Const $iFontFormer = $iArray 																										; Variable definieren: Array Zeiger in $iFontFormer übernehmen
	; ##############################################################################################################################

	; Footer-GUI innerhalb der Info-GUI ############################################################################################
	$aLabelYPos[$iArray + 1] = $aLabelYPos[$iArray] + $aLabelHeight[$iArray]																	; Variable definieren: LabelYPos um LabelHeight in Array #3 erhöhen
	$iArray += 1 																																; Variable definieren: Array Zeiger um 1 erhöhen
	$aLabelHeight[$iArray] = 55	 																												; Variablen-Array definieren: LabelHeight Array #4
	Global Const $iFooter = $iArray 																											; Variable definieren: Array Zeiger in $iFooter übernehmen
	; ##############################################################################################################################

	; Exit-GUI innerhalb der Info-GUI ###############################################################################################
	$aLabelYPos[$iArray + 1] = $iGUI_Height - 60 																								; Variable definieren: LabelYPos setzen (immer von unten an)
	$iArray += 1 																																; Variable definieren: Array Zeiger um 1 erhöhen
	$aLabelHeight[$iArray] = $iExitHeight																										; Variablen-Array definieren: LabelHeight Array #4
	Global Const $iVUMeterShufflePlay = $iArray																									; Variable definieren: Array Zeiger in $iVUMeterShufflePlay übernehmen
	; ##############################################################################################################################

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Headline-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	$hHeadlineGUI = GUICreate ("", $iGUI_Width, $aLabelHeight[$iHeadline], 0, $aLabelYPos[$iHeadline], _										; Headline-GUI erstellen (Teil 1)
								  $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), $hInfoFormGUI)											; Headline-GUI erstellen (Teil 2)
	GUISetBkColor(0x000000, $hHeadlineGUI)																										; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	$hMessage[1] = GUICtrlCreateLabel ("", 0, 0, $iGUI_Width - 4, $aLabelHeight[$iHeadline], BitOR ($SS_CENTER, $SS_CENTERIMAGE))				; GUI Label setzen
	GUICtrlSetOnEvent ($hMessage[1], "_GUI_GetMsg")																								; GUICtrlSetOnEvent: $hMessage[1]
	GUICtrlSetBkColor ($hMessage[1], $GUI_BKCOLOR_TRANSPARENT)																					; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hHeadlineGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Scroller-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global Const $hScrollerGUI = GUICreate ("", $iGUI_Width, $aLabelHeight[$iScroller], $iScrollerXPos, $aLabelYPos[$iScroller], _				; Scroller-GUI erstellen (Teil 1)
											   $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), $hInfoFormGUI)								; Scroller-GUI erstellen (Teil 2)
	GUISetBkColor(0x000000, $hScrollerGUI)																										; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	$hScrollLabel = GUICtrlCreateLabel ("", 0, 0, $iGUI_Width - ($iScrollerXPos * 2), $aLabelHeight[$iScroller], _								; GUI Label setzen (Teil 1)
												  BitOR ($SS_CENTER, $SS_CENTERIMAGE))															; GUI Label setzen (Teil 2)
	GUICtrlSetOnEvent ($hScrollLabel, "_GUI_GetMsg")																							; GUICtrlSetOnEvent: $hScrollLabel
	GUICtrlSetBkColor ($hScrollLabel, $GUI_BKCOLOR_TRANSPARENT)																					; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hScrollerGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; FontFormer-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global Const $hFontFormerGUI = GUICreate ("", $iGUI_Width, $aLabelHeight[$iFontFormer], 0, $aLabelYPos[$iFontFormer], _						; FontFromer-GUI erstellen (Teil 1)
												  $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD, $WS_EX_COMPOSITED), _						; FontFormer-GUI erstellen (Teil 2)
												  $hInfoFormGUI)																				; FontFormer-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hFontFormerGUI)																									; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	$hMessage[2] = GUICtrlCreateLabel ($sFontFormerText, 0, 0, $iGUI_Width, $aLabelHeight[$iFontFormer], $SS_CENTER)							; GUI Label setzen
	GUICtrlSetOnEvent ($hMessage[2], "_GUI_GetMsg")																								; GUICtrlSetOnEvent: $hMessage[2]
	GUICtrlSetColor ($hMessage[2], 0xEEEEEE)																									; Farbe des Labels setzen
	GUICtrlSetFont ($hMessage[2], 12, $FW_HEAVY, 0, "Arial")																					; Textgröße und Stärke des Textes setzen
	GUICtrlSetBkColor ($hMessage[2], $GUI_BKCOLOR_TRANSPARENT)																					; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hFontFormerGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen
	Global $aInfoFormPos = WinGetPos($hInfoFormGUI)																								; Position der Haupt-GUI ermitteln
	WinMove ($hFontFormerGUI, "", $aInfoFormPos[0], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)											; FontFormer-GUI richtig für spätere Effekte positionieren

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Tower-GUI mit Grafiken innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global Const $hLeftTowerGUI = GUICreate ("", $iScrollerXPos, $aLabelHeight[$iScroller] + 40, 40, _											; LeftTower-GUI erstellen (Teil 1)
												 $aLabelYPos[$iScroller] - 25, $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), _			; LeftTower-GUI erstellen (Teil 2)
												 $hInfoFormGUI)																					; LeftTower-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hLeftTowerGUI)																										; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hLeftTowerImage = GUICtrlCreatePic ("", 0, 0, 0, 0)																			; Image-Handle erzeugen
	GUICtrlSetOnEvent ($hLeftTowerImage, "_GUI_GetMsg")																							; GUICtrlSetOnEvent: $hLeftTowerImage
	_WinAPI_SetLayeredWindowAttributes($hLeftTowerGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen

	Global Const $hRightTowerGUI = GUICreate ("", $iScrollerXPos, $aLabelHeight[$iScroller] + 40, $iGUI_Width - $iScrollerXPos - 20, _			; RightTower-GUI erstellen (Teil 1)
												  $aLabelYPos[$iScroller] - 25, $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), _	 		; RightTower-GUI erstellen (Teil 2)
												  $hInfoFormGUI)																				; RightTower-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hRightTowerGUI)																									; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hRightTowerImage = GUICtrlCreatePic ("", 0, 0, 0, 0)																			; Image-Handle erzeugen
	GUICtrlSetOnEvent ($hRightTowerImage, "_GUI_GetMsg")																						; GUICtrlSetOnEvent: $hRightTowerImage
	_WinAPI_SetLayeredWindowAttributes($hRightTowerGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen

	GUICtrlSendMsg($hLeftTowerImage, $STM_SETIMAGE, 0, $ah_Tower_ImageFile[1])																	; Bild 1 in LeftTower-GUI laden
	GUICtrlSendMsg($hRightTowerImage, $STM_SETIMAGE, 0, $ah_Tower_ImageFile[2])																	; Bild 2 in RightTower-GUI laden

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Footer-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	$hFooterGUI = GUICreate ("", $iGUI_Width, $aLabelHeight[$iFooter], 0, $aLabelYPos[$iFooter], _												; Scroller-GUI erstellen (Teil 1)
								 $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), $hInfoFormGUI)												; Scroller-GUI erstellen (Teil 2)
	GUISetBkColor(0x000000, $hFooterGUI)																										; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	$hMessage[3] = GUICtrlCreateLabel ("", 0, 0, $iGUI_Width, $aLabelHeight[$iFooter], BitOR ($SS_CENTER, $SS_CENTERIMAGE))						; GUI Label setzen
	GUICtrlSetOnEvent ($hMessage[3], "_GUI_GetMsg")																								; GUICtrlSetOnEvent: $hMessage[3]
	GUICtrlSetBkColor ($hMessage[3], $GUI_BKCOLOR_TRANSPARENT)																					; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hFooterGUI, 0x000000, 255)																				; Hintergrundfarbe der Image-GUI auf Transparent setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Exit-GUI & VUMeterShufflePlay-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global Const $hExitGUI = GUICreate ("", $iExitWidth - $iExitSpace, $aLabelHeight[$iArray], $iExitPosVUMWidth + $iExitSpace / 2, _			; ExitGUI erstellen (Teil 1)
										    $aLabelYPos[$iArray], $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD), _							; ExitGUI erstellen (Teil 2)
										    $hInfoFormGUI)																						; ExitGUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hExitGUI)																											; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hExitImage = GUICtrlCreatePic ("", 0, 0, 0, 0)																				; Image-Handle erzeugen
	GUICtrlSetOnEvent ($hExitImage, "_GUI_GetMsg")																								; GUICtrlSetOnEvent: $hExitImage
	_WinAPI_SetLayeredWindowAttributes($hExitGUI, 0x000000, 255)																				; Hintergrundfarbe der Image-GUI auf Transparent setzen
	GUICtrlSendMsg($hExitImage, $STM_SETIMAGE, 0, $ah_Exit_ImageFile[1])																		; Bild 1 in LeftTower-GUI laden

	$hVUMeterLeftGUI = GUICreate ("", $iExitPosVUMWidth, 40, 0, $aLabelYPos[$iVUMeterShufflePlay], _											; VUMeterShufflePlayLeft-GUI erstellen (Teil 1)
									  $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD, $WS_EX_COMPOSITED), _									; VUMeterShufflePlayLeft-GUI erstellen (Teil 2)
									  $hInfoFormGUI)																							; VUMeterShufflePlayLeft-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hVUMeterLeftGUI)																									; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hVULTxt = GUICtrlCreateLabel("", 0, 0, $iExitPosVUMWidth, 20, $SS_RIGHT, $WS_EX_COMPOSITED)									; GUI Label setzen
	GUICtrlSetOnEvent ($hVULTxt, "_GUI_GetMsg")																									; GUICtrlSetOnEvent: $hVULTxt
	GUICtrlSetFont($hVULTxt, 14, $FW_HEAVY, 0, "Arial")																							; Textgröße und Stärke des Textes setzen
	Global Const $hVUL = GUICtrlCreateLabel("", 0, 20, $iExitPosVUMWidth, 40, $SS_RIGHT, $WS_EX_COMPOSITED)										; GUI Label setzen
	GUICtrlSetOnEvent ($hVUL, "_GUI_GetMsg")																									; GUICtrlSetOnEvent: $hVUL
	GUICtrlSetFont($hVUL, 16, $FW_HEAVY, 0, "Arial")																							; Textgröße und Stärke des Textes setzen
	GUICtrlSetBkColor ($hVUL, $GUI_BKCOLOR_TRANSPARENT)																							; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hVUMeterLeftGUI, 0x000000, 255)																			; Hintergrundfarbe der Image-GUI auf Transparent setzen

	$hVUMeterRightGUI = GUICreate ("", $iExitPosVUMWidth, 40, $iExitPosVUMWidth + $iExitWidth, $aLabelYPos[$iVUMeterShufflePlay], _				; VUMeterShufflePlayRight-GUI erstellen (Teil 1)
									   $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD, $WS_EX_COMPOSITED), _									; VUMeterShufflePlayRight-GUI erstellen (Teil 2)
									   $hInfoFormGUI)																							; VUMeterShufflePlayRight-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hVUMeterRightGUI)																									; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hVURTxt = GUICtrlCreateLabel("", 0, 0, $iExitPosVUMWidth, 20, $SS_LEFT, $WS_EX_COMPOSITED)									; GUI Label setzen
	GUICtrlSetOnEvent ($hVURTxt, "_GUI_GetMsg")																									; GUICtrlSetOnEvent: $hVURTxt
	GUICtrlSetFont($hVURTxt, 14, $FW_HEAVY, 0, "Arial")																							; Textgröße und Stärke des Textes setzen
	Global Const $hVUR = GUICtrlCreateLabel("", 0, 20, $iExitPosVUMWidth, 40, $SS_LEFT, $WS_EX_COMPOSITED)										; GUI Label setzen
	GUICtrlSetOnEvent ($hVUR, "_GUI_GetMsg")																									; GUICtrlSetOnEvent: $hVUR
	GUICtrlSetFont($hVUR, 16, $FW_HEAVY, 0, "Arial")																							; Textgröße und Stärke des Textes setzen
	GUICtrlSetBkColor ($hVUR, $GUI_BKCOLOR_TRANSPARENT)																							; Label auf Transparent setzen
	_WinAPI_SetLayeredWindowAttributes($hVUMeterRightGUI, 0x000000, 255)																		; Hintergrundfarbe der Image-GUI auf Transparent setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Image-GUI innerhalb der Info-GUI
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global Const $hImageGUI = GUICreate ("", $iImageGUI_Width, $iImageGUI_Height, 0, 0, _														; Image-GUI erstellen (Teil 1)
											 $WS_POPUp, BitOR ($WS_EX_LAYERED, $WS_EX_MDICHILD, $WS_EX_COMPOSITED), _							; Image-GUI erstellen (Teil 2)
											 $hInfoFormGUI)																						; Image-GUI erstellen (Teil 3)
	GUISetBkColor(0x000000, $hImageGUI)																											; Hintergrundfarbe setzen, welche später Transparent gemacht wird
	Global Const $hImageFile = GUICtrlCreatePic ("", 0, 0, 0, 0)																				; Image-Handle erzeugen
	GUICtrlSetOnEvent ($hImageFile, "_GUI_GetMsg")																								; GUICtrlSetOnEvent: $hImageFile
	_WinAPI_SetLayeredWindowAttributes($hImageGUI, 0x000000, 255)																				; Hintergrundfarbe der Image-GUI auf Transparent setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Alle GUIs in der passenden Reihenfolge anzeigen (wer zu letzt kommt, überdeckt ggf. die anderen)
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	GUISetState (@SW_SHOW, $hHeadlineGUI)																										; Headline-GUI darstellen
	GUISetState (@SW_SHOW, $hFontFormerGUI)																										; FontFormer-GUI darstellen
	GUISetState (@SW_SHOW, $hScrollerGUI)																										; Scroller-GUI darstellen
	GUISetState (@SW_SHOW, $hLeftTowerGUI)																										; LeftTower-GUI anzeigen
	GUISetState (@SW_SHOW, $hRightTowerGUI)																										; RightTower-GUI anzeigen
	GUISetState (@SW_SHOW, $hFooterGUI)																											; Footer-GUI darstellen
	GUISetState (@SW_SHOW, $hExitGUI)																											; Exit-GUI darstellen
	GUISetState (@SW_SHOW, $hVUMeterLeftGUI)																									; VUMeterShufflePlayLeft-GUI anzeigen
	GUISetState (@SW_SHOW, $hVUMeterRightGUI)																									; VUMeterShufflePlayRight-GUI anzeigen
	GUISetState (@SW_SHOW, $hInfoFormGUI)																										; Info-GUI darstellen
	GUISwitch($hInfoFormGUI)																													; Info-GUI - hier spielt die Musik
	
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; FMOD.dll Chip Music Startup
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $hCT_SongData = True, $CT_MEMLen, $CT_MEMData, $iCT_AllChannels, $iCT_SongLength, $iCT_Complete = False, $iCT_SongManual = False		; Globale Variablen initialisieren
	Global $iVolFadeOut, $iCT_SongNr = Random (1, $iCT_SongsMax, 1), $iCT_SongActual = 99, $sCT_SongStatus, $hCT_SongName, $hSoundFile			; Globale Variablen initialisieren

	Global $i_MDCodeBuffer, $i_MDLoadOffset, $i_MDGetOffset, $i_MDFreeOffset, $p_MFHookPtr, $i_MFHookBak, $s_MFHookApi = "GlobalCompact"		; Globale Variablen initialisieren
	Global $h_MDKernel32Dll = DllOpen("kernel32.dll")																							; Globale Variablen initialisieren

	_MemoryDllInit()																															; Funktion anspringen: Memory.dll Init

	Global $h_MDFmodDll = _MemoryDllOpen(_FMOD_DLL()), $iFSOUND_LOADMEMORY = 0x00008000															; Globale Variablen initialisieren

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Init Font Wobbler Text
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Local $iFW_FontSize = $iGUI_Width / 13																										; Lokale Variable initialisieren und definieren: Schriftgröße festelegen
	Global $aFW_Bounds																															; Globale Variable initialisieren
	Global $hFW_Graphics = _GDIPlus_GraphicsCreateFromHWND (ControlGetHandle($hHeadlineGUI, "", $hMessage[1]))									; Globale Variable definieren: GDIPlus: Grafik-Objekt aus GUI Handle erstellen
	Global $hFW_Bitmap = _GDIPlus_BitmapCreateFromGraphics($iGUI_Width - 4, $aLabelHeight[$iHeadline], $hFW_Graphics)							; Globale Variable definieren: GDIPlus: Bitmap-Objekt erstellen, basierend auf der Breite und Höhe eines Grafik-Objekts
	Global $hFW_Context = _GDIPlus_ImageGetGraphicsContext($hFW_Bitmap)																			; Globale Variable definieren: GDIPlus: Grafikkontext des Bildes holen
	
	_GDIPlus_GraphicsSetSmoothingMode($hFW_Context, $GDIP_SMOOTHINGMODE_HIGHQUALITY)															; GDIPlus: Legt die Qualität des Grafikobjekt-Renderings fest
	
	Global $hFW_Pen = _GDIPlus_PenCreate(0xFFFF0000, 2)																							; Globale Variable definieren: GDIPlus: Stiftobjekt erstellen und Farbe setzen
	Local $hFW_Path = _GDIPlus_PathCreate()																										; Lokale Variable definieren: GDIPlus:
	Local $hFW_Format = _GDIPlus_StringFormatCreate()																							; Lokale Variable definieren: GDIPlus:
	
	_GDIPlus_StringFormatSetAlign($hFW_Format, 1)																								; GDIPlus: Legt die Textausrichtung eines Zeichenfolgenformatobjekts fest
	
	Local $hFW_FFamily = _GDIPlus_FontFamilyCreate("Franklin Gothic Medium")																	; Lokale Variable definieren: GDIPlus: Font Family Objekt erstellen
	Local $aFW_Rectf = _GDIPlus_RectFCreate(0, 0, $iGUI_Width - 4, $aLabelHeight[$iHeadline])													; Lokale Variable definieren: GDIPlus: Struktur erstellen
	
	_GDIPlus_PathAddString($hFW_Path, $sHeadlineText, $aFW_Rectf, $hFW_FFamily, 0, $iFW_FontSize, $hFW_Format)									; GDIPlus: Fügt die Gliederung eines Strings zu einem Pfad hinzu
	_GDIPlus_StringFormatDispose($hFW_Format)																									; GDIPlus: Objekt löschen
	_GDIPlus_FontFamilyDispose($hFW_FFamily)																									; GDIPlus: Objekt löschen
	
	Global $pFW_Iter = _GDIPlus_PathIterCreate($hFW_Path)																						; Globale Variable definieren: GDIPlus: Erstellt ein neues GraphicsPathIterator-Objekt und ordnet es einem GraphicsPath-Objekt zu
	Global $pFW_IterCnt = _GDIPlus_PathIterGetSubpathCount($pFW_Iter)																			; Globale Variable definieren: GDIPlus: Ruft die Anzahl der Teilpfade (auch Abbildung genannt) im Pfad ab
	Global $hFW_SubPath = _GDIPlus_PathCreate()																									; Globale Variable definieren: GDIPlus: Erstellt ein GraphicsPath-Objekt und initialisiert den Füllmodus
	Global $hFW_Matrix = _GDIPlus_MatrixCreate()																								; Globale Variable definieren: GDIPlus: Erstellt und initialisiert ein Matrixobjekt, das die Identitätsmatrix darstellt

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Load Font from Memory and init Scroller Text
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $hST_Graphics = _GDIPlus_GraphicsCreateFromHWND (ControlGetHandle($hScrollerGUI, "", $hScrollLabel))									; Variable definieren: GDIPlus: Grafik-Objekt aus GUI Handle erstellen
	Global $hST_Bitmap = _GDIPlus_BitmapCreateFromGraphics ($iGUI_Width - ($iScrollerXPos * 2), $aLabelHeight[$iScroller], $hST_Graphics)		; Variable definieren: GDIPlus: Bitmap-Objekt erstellen, basierend auf der Breite und Höhe eines Grafik-Objekts
	Global $hST_Context = _GDIPlus_ImageGetGraphicsContext ($hST_Bitmap)																		; Variable definieren: GDIPlus: Grafikkontext des Bildes holen

	Global $hST_Collection = _GDIPlus_PrivateCollectionCreate()																					; Variable definieren: GDIPlus_PrivateCollection: Init
	Global $aST_LoadScrollerFont = _FontFile1()																									; Variable definieren: Font-Data aus MEM holen
	Global $iST_FontMEM = DllStructCreate('byte[' & BinaryLen($aST_LoadScrollerFont[2]) & ']')													; Variable definieren: Struktur des Elements erstellen
	
	DllStructSetData($iST_FontMEM, 1, $aST_LoadScrollerFont[2])																					; Setzt die Daten eines Elements in der Struktur
	_GDIPlus_PrivateCollectionAddMemoryFont($hST_Collection, DllStructGetPtr($iST_FontMEM), DllStructGetSize($iST_FontMEM))						; Variable definieren: GDIPlus_PrivateCollection: Font im Speicher erstellen
	
	Global $hST_FFamily = _GDIPlus_CreateFontFamilyFromName($aST_LoadScrollerFont[1], $hST_Collection)											; Variable definieren: GDIPlus_PrivateCollection: Font Family Objekt erstellen
	Global $hST_ScrollerFont = _GDIPlus_FontCreate($hST_FFamily, 24)																			; Variable definieren: GDIPlus: Font Objekt erstellen

	Global $hST_Format = _GDIPlus_StringFormatCreate()																							; Variable definieren: GDIPlus: String Format-Objekt erstellen
	
	_GDIPlus_StringFormatSetAlign ($hST_Format, 1)																								; GDIPlus: Legt die Textausrichtung eines Zeichenfolgenformatobjekts fest
	
	Global $hST_Brush = _GDIPlus_BrushCreateSolid()																								; Variable definieren: GDIPlus: Solides Brush-Objekt erstellen

	Global $aST_Rectf = _GDIPlus_RectFCreate (0, 0, 0, 0)																						; Variable definieren: GDIPlus Struktur erstellen
	Global $aST_MeasureStr = _GDIPlus_GraphicsMeasureString ($hST_Graphics, $sSW_ScrollText, $hST_ScrollerFont, $aST_Rectf, $hST_Format)		; Variable definieren: GDIPlus: Misst die Größe eines Strings
	Global $iST_ScrollWidth = Int (DllStructGetData ($aST_MeasureStr[0], "width"))																; Variable definieren: Breite des Strings abrufen

	Global $iSW_ScrollRight = $iST_ScrollWidth / 2, $iSW_ScrollLeft = -$iSW_ScrollRight, $sScrollTextLen = $iGUI_Width - ($iScrollerXPos * 2)	; Globale Variablen initialisieren
	Global $iSW_ScrollCenter = ($iGUI_Width / 2) - ($iScrollerXPos * 3), $iSW_ScrollPos = $iSW_ScrollRight + $iSW_ScrollCenter					; Globale Variablen initialisieren

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Load Font from Memory and init Footer Text
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Local $hFT_Graphics = _GDIPlus_GraphicsCreateFromHWND(ControlGetHandle($hFooterGUI, "", $hMessage[3]))										; Variable definieren: GDIPlus: Grafik-Objekt aus GUI Handle erstellen
	Local $hFT_Bitmap = _GDIPlus_BitmapCreateFromGraphics($iGUI_Width, $aLabelHeight[$iFooter], $hFT_Graphics)									; Variable definieren: GDIPlus: Bitmap-Objekt erstellen, basierend auf der Breite und Höhe eines Grafik-Objekts
	Local $hFT_Context = _GDIPlus_ImageGetGraphicsContext($hFT_Bitmap)																			; Variable definieren: GDIPlus: Grafikkontext des Bildes holen

	Local $hFT_Collection = _GDIPlus_PrivateCollectionCreate()																					; Variable definieren: GDIPlus_PrivateCollection: Init
	Local $aFT_LoadFooterFont = _FontFile2()																									; Variable definieren: Font-Data aus MEM holen
	Local $iFT_FontMEM = DllStructCreate('byte[' & BinaryLen($aFT_LoadFooterFont[2]) & ']')														; Variable definieren: Struktur des Elements erstellen
	
	DllStructSetData($iFT_FontMEM, 1, $aFT_LoadFooterFont[2])																					; Setzt die Daten eines Elements in der Struktur
	_GDIPlus_PrivateCollectionAddMemoryFont($hFT_Collection, DllStructGetPtr($iFT_FontMEM), DllStructGetSize($iFT_FontMEM))						; Variable definieren: GDIPlus_PrivateCollection: Font im Speicher erstellen
	
	Local $hFT_FFamily = _GDIPlus_CreateFontFamilyFromName($aFT_LoadFooterFont[1], $hFT_Collection)												; Variable definieren: GDIPlus_PrivateCollection: Font Family Objekt erstellen
	Local $hFT_FooterFont = _GDIPlus_FontCreate($hFT_FFamily, 25)																				; Variable definieren: GDIPlus: Font Objekt erstellen

	Local $hFT_Format = _GDIPlus_StringFormatCreate()																							; Variable definieren: GDIPlus: String Format-Objekt erstellen
	
	_GDIPlus_StringFormatSetAlign ($hFT_Format, 1)																								; GDIPlus: Legt die Textausrichtung eines Zeichenfolgenformatobjekts fest
	
	Local $hFT_Brush = _GDIPlus_BrushCreateSolid(0xFF999999)																					; Variable definieren: GDIPlus: Solides Brush-Objekt erstellen

	_GDIPlus_GraphicsClear ($hFT_Context, 0xFF000000)																							; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
	
	Local $aFT_Rectf = _GDIPlus_RectFCreate (0, -5, $iGUI_Width, $aLabelHeight[$iFooter])														; Variable definieren: GDIPlus Struktur erstellen
	
	_GDIPlus_GraphicsDrawStringEx ($hFT_Context, $sForceText, $hFT_FooterFont, $aFT_Rectf, $hFT_Format, $hFT_Brush)								; GDIPlus: String zeichnen
	_GDIPlus_GraphicsDrawImageRect ($hFT_Graphics, $hFT_Bitmap, 0, 0, $iGUI_Width, $aLabelHeight[$iFooter])										; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Zweifache DO Schleife
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Global $iKeyPressed = False																													; Globale Variable initialisieren: KeyPressed auf FALSE setzen
	_WhichKey_Startup()																															; Funktion anspringen: _WhichKey_Startup

	Global $aColRot[4] = [Dec("FFF0FF"), Dec("FFF000"), Dec("00FFF0"), Dec("000FFF")]															; Variablen-Array definieren: FarbRotation für iMessage[1], iMessage[3], iMessage[2], iMessage[3]
	Local $iDO_LoopSwitch = True																												; Variable initialisieren und definieren: DO-Schleife Modus fest auf "True" stellen

	_FSOUND_Init()																																; Funktion anspringen: Sound-Engine Init

	$iCpsTimer = TimerInit()																													; Variable definieren: CPS TimerInit
	Global $hTimerCalcCPS = _Timer_SetTimer($hInfoFormGUI, 1000, "CalcCPS")																		; _Timer_SetTimer: Funktion CalcCPS alle 1000ms anspringen
	Global $hTimerAutoPlay = _Timer_SetTimer($hInfoFormGUI, 30000, "AutoPlay")																	; _Timer_SetTimer: Funktion AutoPlay nach 30000ms anspringen
	Global $hTimerFontWobbler = _Timer_SetTimer($hInfoFormGUI, 100, "FontWobbler")																; _Timer_SetTimer: Funktion FontWobbler alle 100ms anspringen
	Global $hTimerTextSlider = _Timer_SetTimer($hInfoFormGUI, 30, "TextSlider")																	; _Timer_SetTimer: Funktion TextSlider alle 30ms anspringen
	Global $hTimerStarWarsScroller = _Timer_SetTimer($hInfoFormGUI, 30, "StarWarsScroller")														; _Timer_SetTimer: Funktion StarWarsScroller alle 30ms anspringen
	Global $hTimerStarWarsImageMove = _Timer_SetTimer($hInfoFormGUI, 25, "StarWarsImageMove")													; _Timer_SetTimer: Funktion StarWarsImageMove alle 25ms anspringen
	Global $hTimerVUMeterShufflePlayPause = _Timer_SetTimer($hInfoFormGUI, 60, "VUMeterShufflePlayPause")										; _Timer_SetTimer: Funktion VUMeterShufflePlayPause alle 60ms anspringen

	Do																																			; Do-Schleife: Hauptschleife

		_SleepDelay(False)																														; Sleep-Timer initialisieren
		$iDO_LoopCounter = 0																													; Variable definieren: Oberhalb der 1. DO-Schleife

;~ 	 	$sCW_Text = "Just say peep! $iDO_LoopCounter: " & $iDO_LoopCounter																		; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

		Do																																		; Do-Schleife: Unterschleife

			Local $iDoTimer = TimerInit()																										; Lokale Variable definieren: Do TimerInit

			If $iDO_LoopSwitch Then $iDO_ScrollPos += $iDO_ScrollPosStep																		; If-Abfrage: Welcher DoLoop Modus ist aktiv? 
			If Not $iDO_LoopSwitch Then $iDO_ScrollPos -= $iDO_ScrollPosStep																	; If-Abfrage: Welcher DoLoop Modus ist aktiv? 
	
			If Not $iTextSlider Then _GDIPlus_GraphicsDrawImageRect ($hFT_Graphics, $hFT_Bitmap, 0, 0, $iGUI_Width, $aLabelHeight[$iFooter])		; If-Abfrage: GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle?

			If $iKeyPressed And BitAND (WinGetState ($hInfoFormGUI), 8) Then _Key_IsPressed()			 										; If-Abfrage: Ist eine Taste gedrückt worden und ist die InfoForm-GUI aktiv?
			$iKeyPressed = False																												; Variable definieren: $iKeyPressed wieder auf "FALSE" setzen
			
			ToggleChipTune()																													; Funktion anspringen: ToggleChipTune
			VUMeterVolFadeOut()																													; Funktion anspringen: VUMeterVolFadeOut
			
			EffectsRotate ($hFT_Context, $hFT_FooterFont, $aFT_Rectf, $hFT_Format, $hFT_Brush, $hFT_Graphics, $hFT_Bitmap, _					; Funktion anspringen: EffectsRotate (Teil 1)
						   $sForceText, $iFooter, $aLabelHeight, $iDO_ScrollPos)																	; Funktion anspringen: EffectsRotate (Teil 2)

			_SleepDelay ($iDO_SleepWait)																										; Funktion anspringen: SleepDelay

			$iDO_LoopCounter = 1																												; Variable definieren: Innerhlab der 1. DO-Schleife

;~ 			$sCW_Text = "Just say peep! $iDO_LoopCounter: " & $iDO_LoopCounter																	; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

;~ 			$sCW_Text = "Current running mode - TextSlider: " & $iTextSlider & " - Star Wars: " & $iSW_Enable									; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

			If $iDebugTimer Then $sCW_Text = "Elepsaed time within DoLoop: " & TimerDiff ($iDoTimer)											; Variable definieren: $sCW_Text
			If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																	; If-Abfrage: Funktion anspringen: Ausgabe Console

		Until $iDO_ScrollPos > $iLen Or $iDO_ScrollPos < -$iLen Or $iInfoBoxExitButton															; Ende der Do-Schleife: Unterschelife

		$iDO_LoopSwitch = Not $iDO_LoopSwitch																									; Variable definieren: DO-Schleife Modus wechseln
		$iDO_LoopCounter = 2																													; Variable definieren: Zwischen der 1. und der 2. DO-Schleife

;~ 	 	$sCW_Text = "Just say peep! $iDO_LoopCounter: " & $iDO_LoopCounter																		; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

	Until $iInfoBoxExitButton																													; Ende der Do-Schleife: Funktion verlassen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	; Aufräumen und Programmende
	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	_Timer_KillAllTimers($hInfoFormGUI)																											; _Timer_KillAllTimers: Alle _Timer_SetTimer deaktivieren

	_WhichKey_Shutdown()																														; Funktion anspringen: _WhichKey_Shutdown

	_GDIPlus_MatrixDispose($hFW_Matrix)																											; GDIPlus: Objekt löschen
	_GDIPlus_PathDispose($hFW_SubPath)																											; GDIPlus: Objekt löschen
	_GDIPlus_PathIterDispose($pFW_Iter)																											; GDIPlus: Objekt löschen
	_GDIPlus_PathDispose($hFW_Path)																												; GDIPlus: Objekt löschen
	_GDIPlus_PenDispose($hFW_Pen)																												; GDIPlus: Objekt löschen
    _GDIPlus_FontFamilyDispose ($hFW_FFamily)																									; GDIPlus: Objekt löschen
	_GDIPlus_GraphicsDispose($hFW_Context)																										; GDIPlus: Objekt löschen
	_GDIPlus_BitmapDispose($hFW_Bitmap)																											; GDIPlus: Objekt löschen
	_GDIPlus_GraphicsDispose($hFW_Graphics)																										; GDIPlus: Objekt löschen
	
	_GDIPlus_BrushDispose ($hST_Brush)																											; GDIPlus: Objekt löschen
    _GDIPlus_StringFormatDispose ($hST_Format)																									; GDIPlus: Objekt löschen
    _GDIPlus_FontDispose ($hST_ScrollerFont)																									; GDIPlus: Objekt löschen
    _GDIPlus_FontFamilyDispose ($hST_FFamily)																									; GDIPlus: Objekt löschen
    _GDIPlus_GraphicsDispose ($hST_Context)																										; GDIPlus: Objekt löschen
    _GDIPlus_BitmapDispose ($hST_Bitmap)																										; GDIPlus: Objekt löschen
    _GDIPlus_GraphicsDispose ($hST_Graphics)																									; GDIPlus: Objekt löschen
	_GDIPlus_PrivateFontCollectionDispose($hST_Collection)																						; GDIPlus: Objekt löschen

	_GDIPlus_BrushDispose ($hFT_Brush)																											; GDIPlus: Objekt löschen
    _GDIPlus_StringFormatDispose ($hFT_Format)																									; GDIPlus: Objekt löschen
    _GDIPlus_FontDispose ($hFT_FooterFont)																										; GDIPlus: Objekt löschen
    _GDIPlus_FontFamilyDispose ($hFT_FFamily)																									; GDIPlus: Objekt löschen
    _GDIPlus_GraphicsDispose ($hFT_Context)																										; GDIPlus: Objekt löschen
    _GDIPlus_BitmapDispose ($hFT_Bitmap)																										; GDIPlus: Objekt löschen
    _GDIPlus_GraphicsDispose ($hFT_Graphics)																									; GDIPlus: Objekt löschen
	_GDIPlus_PrivateFontCollectionDispose($hFT_Collection)																						; GDIPlus: Objekt löschen

	_FMUSIC_StopSong($hSoundFile)																												; Funktion anspringen: StopSong
	_FSOUND_Close()																																; Funktion anspringen: Sound-Engine schliessen
	_MemoryDllClose($h_MDFmodDll)																												; Funktion anspringen: MemoryDLL schliessen
	_MemoryDllExit()																															; Funktion anspringen: MemoryDLL beenden
	DllClose($h_MDKernel32Dll)																													; Funktion anspringen: DLL schliessen
	$ah_ChipMusicMEM = False																													; Variable definieren: Inhalt löschen
	$CT_MEMData = False																															; Variable definieren: Inhalt löschen
	$hCT_SongData = False																														; Variable definieren: Inhalt löschen

	GUIDelete ($hVUMeterRightGUI)																												; VUMeterShufflePlayRight-GUI löschen
	GUIDelete ($hVUMeterLeftGUI)																												; VUMeterShufflePlayLeft-GUI löschen
	GUIDelete ($hFooterGUI)																														; Footer-GUI löschen
	GUIDelete ($hScrollerGUI)																													; Scroller-GUI löschen
	GUIDelete ($hRightTowerGUI)																													; RightTower-GUI löschen
	GUIDelete ($hLeftTowerGUI)																													; LeftTower-GUI löschen
	GUIDelete ($hFontFormerGUI)																													; FontFormer-GUI löschen
	GUIDelete ($hHeadlineGUI)																													; Headline-GUI löschen
	GUIDelete ($hImageGUI)																														; Image-GUI löschen
	GUIDelete ($hInfoFormGUI)																													; Info-GUI löschen

	Opt ("GUIOnEventMode", 0)																													; OnEvent Aktionen in der GUI verbieten

	If (@OSVersion = "WIN_10") Then GUICtrlDelete ($hInfoButtonJoke)																			; Label in Haupt GUI löschen
	$hInfoButton = GUICtrlCreateLabel (ChrW(928), 387, 3, 7, 12)																				; Label Text in Haupt GUI auf Default setzen

	; --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

EndFunc																																			; Funktionsende: _InfoBox

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: CalcCPS (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func CalcCPS($hWnd, $iMsg, $iIDTimer, $iTime)																									; Funktionsstart: CalcCPS

	Local $sCW_Text																																; Variable definieren
	
	$aER_CPS[0] = StringFormat ("%02d", $aER_CPS[0])																							; Variable definieren: 2-stellig formatieren
	$aFW_CPS[0] = StringFormat ("%02d", $aFW_CPS[0])																							; Variable definieren: 2-stellig formatieren
	$aTS_CPS[0] = StringFormat ("%02d", $aTS_CPS[0])																							; Variable definieren: 2-stellig formatieren
	$aSW_CPS[0] = StringFormat ("%02d", $aSW_CPS[0])																							; Variable definieren: 2-stellig formatieren
	$aSI_CPS[0] = StringFormat ("%02d", $aSI_CPS[0])																							; Variable definieren: 2-stellig formatieren
	$aVM_CPS[0] = StringFormat ("%02d", $aVM_CPS[0])																							; Variable definieren: 2-stellig formatieren

	Local $AllCPS = "ER: " & $aER_CPS[0] & _																									; Lokale Variable initialisieren und definieren (Teil 1)
					" / FW: " & $aFW_CPS[0] & _																									; Lokale Variable initialisieren und definieren (Teil 2)
					" / TS: " & $aTS_CPS[0] & _																									; Lokale Variable initialisieren und definieren (Teil 3)
					" / SW: " & $aSW_CPS[0] & _																									; Lokale Variable initialisieren und definieren (Teil 4)
					" / SI: " & $aSI_CPS[0] & _																									; Lokale Variable initialisieren und definieren (Teil 5)
					" / VM: " & $aVM_CPS[0]																										; Lokale Variable initialisieren und definieren (Teil 6)
	Local $AllCycles = ($aER_CPS[1] + $aFW_CPS[1] + $aTS_CPS[1] + $aSW_CPS[1] + $aSI_CPS[1] + $aVM_CPS[1]) / 6									; Lokale Variable initialisieren und definieren

	$iShowCPS = $AllCPS & " / Ø " & Round ($AllCycles / TimerDiff ($iCpsTimer) * 1000, 4)														; Variable definieren: AllCPS ermitteln
	
	$aER_CPS[0] = 0																																; Variable definieren: $aER_CPS[0] zurücksetzen
	$aFW_CPS[0] = 0																																; Variable definieren: $aTS_CPS[0] zurücksetzen
	$aTS_CPS[0] = 0																																; Variable definieren: $aTS_CPS[0] zurücksetzen
	$aSW_CPS[0] = 0																																; Variable definieren: $aSW_CPS[0] zurücksetzen
	$aSI_CPS[0] = 0																																; Variable definieren: $aSI_CPS[0] zurücksetzen
	$aVM_CPS[0] = 0																																; Variable definieren: $aVM_CPS[0] zurücksetzen

 	If $iDebugTimer Then $sCW_Text = "CPS: " & $iShowCPS																						; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: CalcCPS

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _SleepDelay
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _SleepDelay($_SleepWait = 30)																												; Funktionsstart: _SleepDelay

	Local Static $_Sleep, $_SleepDiff																											; Lokale Static Variablen definieren

	If Not $_SleepWait Then																														; If-Abfrage: Wurde "False" übergeben?

		$_Sleep = TimerInit()																													; Sleep-Timer initialisieren

	Else																																		; Else-Abfrage: Wurde "False" übergeben?

		$_SleepDiff = $_SleepWait - TimerDiff ($_Sleep)																							; Durchlauf-Differenz ermitteln und festhalten
		If $_SleepDiff > 0 Then Sleep ($_SleepDiff)																								; In Abhängigkeit, wie lange der Durchlauf gebraucht hat, den Rest von $_SleepWait noch pausieren
		$_Sleep = TimerInit()																													; Sleep-Timer erneut initialisieren

		WinSetTitle ($hInfoFormGUI, "", "The info behind the pi -_- InfoBox CPS (Cycles Per Second): " & $iShowCPS)								; Title der InfoForm-GUI anpassen

	EndIf																																		; Ende der If-Abfrage: Wurde "False" übergeben?

EndFunc																																			; Funktionsende: _SleepDelay

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _ConsoleWrite
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _ConsoleWrite($ScriptLN, $ValueNew)																										; Funktionsstart: _ConsoleWrite

	Local Static $ValueOld																														; Lokale Static Variable definieren
	
	If $ValueNew <> $ValueOld Then																												; If-Abfrage: Hat sich der Übergabewert verändert?
		
		ConsoleWrite("Script #(" & $ScriptLN & ") - " & $ValueNew & @CRLF)																		; Ausgabe Console: $ValueOld
		$ValueOld = $ValueNew																													; If-Abfrage: Wenn der Übergabewert vom vorherigen abweicht, den neuen übernehmen
	
	EndIf																																		; Ende der If-Abfrage: Hat sich der Übergabewert verändert?
	
EndFunc																																			; Funktionsende: _ConsoleWrite

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _Key_IsPressed
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _Key_IsPressed()																															; Funktionsstart: _Key_IsPressed

	Local $sCW_Text																																; Variable initialisieren

;~ 	$sCW_Text = "ASCII Code: " & $iKeyPressed																									; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

	Switch $iKeyPressed																															; Switch-Abfrage: Welche Taste wurde gedrückt?

		; Spacebar zum Aktivieren bzw. Deaktivieren des Slider Modus ###################################################################
		Case 32																																	; Case: ASCII Code 32
			ScrollStartStop()																													; Funktion anspringen: Scroller aktivieren bzw. deaktivieren
		; ##############################################################################################################################

		; Enter zum Aktivieren bzw. Deaktivieren des StarWars Modus ####################################################################
		Case 13																																	; Case: ASCII Code 13
			StarWarsEnable()																													; Funktion anspringen: StarWars Modus aktivieren bzw. deaktivieren
		; ##############################################################################################################################

		; Pfeil links und rechts für Wahl des Hintergrundbildes ########################################################################
		Case 37																																	; Case: ASCII Code 37
			If Not $iSW_Enable Then																												; If-Abfrage: Ist der StarWars Mode aus?
				$iBG_NormalNr -= 1																												; Variable definieren: Hintergrundbildnummer für Normal Modus um 1 verringern
				If $iBG_NormalNr < 1 Then $iBG_NormalNr = $iBG_NormalMax																		; If-Abfrage: Ist die Hintergrundbildnummer kleiner 1, dann erneut auf $iBG_NormalMax setzen
				LoadBGImage()																													; Funktion anspringen: Hintergrundbild laden
			ElseIf $iSW_Enable Then																												; ElseIf-Abfrage: Ist der StarWars Mode an?
				$iBG_StarWarsNr -= 1																											; Variable definieren: Hintergrundbildnummer für StarWars Modus um 1 verringern
				If $iBG_StarWarsNr < 1 Then $iBG_StarWarsNr = $iBG_StarWarsMax																	; If-Abfrage: Ist die Hintergrundbildnummer für StarWars Modus kleiner 1, dann erneut auf $iBG_StarWarsMax setzen
				LoadBGImage()																													; Funktion anspringen: Hintergrundbild laden
			EndIf																																; Ende der If-Abfrage: Ist der StarWars Mode aus?
		Case 39																																	; Case: ASCII Code 39
			If Not $iSW_Enable Then																												; If-Abfrage: Ist der StarWars Mode aus?
				$iBG_NormalNr += 1																												; Variable definieren: Hintergrundbildnummer für Normal Modus um 1 erhöhen
				If $iBG_NormalNr > $iBG_NormalMax Then $iBG_NormalNr = 1																		; If-Abfrage: Ist die Hintergrundbildnummer größer $iBG_NormalMax, dann erneut auf 1 setzen
				LoadBGImage()																													; Funktion anspringen: Hintergrundbild laden
			ElseIf $iSW_Enable Then																												; ElseIf-Abfrage: Ist der StarWars Mode an?
				$iBG_StarWarsNr += 1																											; Variable definieren: Hintergrundbildnummer für StarWars Modus um 1 erhöhen
				If $iBG_StarWarsNr > $iBG_StarWarsMax Then $iBG_StarWarsNr = 1																	; If-Abfrage: Ist die Hintergrundbildnummer größer $iBG_StarWarsMax, dann erneut auf 1 setzen
				LoadBGImage()																													; Funktion anspringen: Hintergrundbild laden
			EndIf																																; Ende der If-Abfrage: Ist der StarWars Mode aus?
		; ##############################################################################################################################

		; Key 1 bis 9 für Wahl des Musikstückes ########################################################################################
		Case 49																																	; Case: ASCII Code 049 - Key 1
			$iCT_SongNr = 1																														; Song Nr. 1
		Case 50																																	; Case: ASCII Code 050 - Key 2
			$iCT_SongNr = 2																														; Song Nr. 2
		Case 51																																	; Case: ASCII Code 051 - Key 3
			$iCT_SongNr = 3																														; Song Nr. 3
		Case 52																																	; Case: ASCII Code 052 - Key 4
			$iCT_SongNr = 4																														; Song Nr. 4
		Case 53																																	; Case: ASCII Code 053 - Key 5
			$iCT_SongNr = 5																														; Song Nr. 5
		Case 54																																	; Case: ASCII Code 054 - Key 6
			$iCT_SongNr = 6																														; Song Nr. 6
		Case 55																																	; Case: ASCII Code 055 - Key 7
			$iCT_SongNr = 7																														; Song Nr. 7
		Case 56																																	; Case: ASCII Code 056 - Key 8
			$iCT_SongNr = 8																														; Song Nr. 8
		Case 57																																	; Case: ASCII Code 057 - Key 9
			$iCT_SongNr = 9																														; Song Nr. 9
		; ##############################################################################################################################

		; Num 0 bis 9 für Wahl des Musikstückes aus der ChipMusicXtra.dat Datei ########################################################
		Case 96																																	; Case: ASCII Code 096 - Num 0
			$iCT_SongNr = 10																													; Song Nr. 10
		Case 97																																	; Case: ASCII Code 097 - Num 1
			$iCT_SongNr = 11																													; Song Nr. 11
		Case 98																																	; Case: ASCII Code 098 - Num 2
			$iCT_SongNr = 12																													; Song Nr. 12
		Case 99																																	; Case: ASCII Code 099 - Num 3
			$iCT_SongNr = 13																													; Song Nr. 13
		Case 100																																; Case: ASCII Code 100 - Num 4
			$iCT_SongNr = 14																													; Song Nr. 14
		Case 101																																; Case: ASCII Code 101 - Num 5
			$iCT_SongNr = 15																													; Song Nr. 15
		Case 102																																; Case: ASCII Code 102 - Num 6
			$iCT_SongNr = 16																													; Song Nr. 16
		Case 103																																; Case: ASCII Code 103 - Num 7
			$iCT_SongNr = 17																													; Song Nr. 17
		Case 104																																; Case: ASCII Code 104 - Num 8
			$iCT_SongNr = 18																													; Song Nr. 18
		Case 105																																; Case: ASCII Code 105 - Num 9
			$iCT_SongNr = 19																													; Song Nr. 19
		; ##############################################################################################################################

		; Key # für den Start/Pause der Musik auch wenn der Scroller aus ist ###########################################################
		Case 191																																; Case: ASCII Code 191 - Key #
			If Not $iSW_Enable Then ManualChipTune (True)																						; If-Abfrage: Funktion anspringen: Ist der StarWarsModus deaktiviert, dann Music Start/Pause
		; ##############################################################################################################################

		; Key + und - für Wahl des StarWars JEDI FORCE #################################################################################
		Case 187																																; Case: ASCII Code 187 - Key +
			StarWarsForceEnable()																												; Funktion anspringen: StarWarsForceEnable
		Case 107																																; Case: ASCII Code 107 - Num +
			StarWarsForceEnable()																												; Funktion anspringen: StarWarsForceEnable
		Case 189																																; Case: ASCII Code 189 - Key -
			StarWarsForceDisable()																												; Funktion anspringen: StarWarsForceDisable
		Case 109																																; Case: ASCII Code 109 - Num -
			StarWarsForceDisable()																												; Funktion anspringen: StarWarsForceDisable
		; ##############################################################################################################################

		; F1 bis F9 für Wahl des StarWars Bildes #######################################################################################
		Case 112																																; Case: ASCII Code 112 - Key F1
			StarWarsImageToggleShow(1)																											; Funktion anspringen: StarWarsImageToggleShow(1)
		Case 113																																; Case: ASCII Code 113 - Key F2
			StarWarsImageToggleShow(2)																											; Funktion anspringen: StarWarsImageToggleShow(2)
		Case 114																																; Case: ASCII Code 114 - Key F3
			StarWarsImageToggleShow(3)																											; Funktion anspringen: StarWarsImageToggleShow(3)
		Case 115																																; Case: ASCII Code 115 - Key F4
			StarWarsImageToggleShow(4)																											; Funktion anspringen: StarWarsImageToggleShow(4)
		Case 116																																; Case: ASCII Code 116 - Key F5
			StarWarsImageToggleShow(5)																											; Funktion anspringen: StarWarsImageToggleShow(5)
		Case 117																																; Case: ASCII Code 117 - Key F6
			StarWarsImageToggleShow(6)																											; Funktion anspringen: StarWarsImageToggleShow(6)
		Case 118																																; Case: ASCII Code 118 - Key F7
			StarWarsImageToggleShow(7)																											; Funktion anspringen: StarWarsImageToggleShow(7)
		Case 119																																; Case: ASCII Code 119 - Key F8
			StarWarsImageToggleShow(8)																											; Funktion anspringen: StarWarsImageToggleShow(8)
		Case 120																																; Case: ASCII Code 120 - Key F9
			StarWarsImageToggleShow(9)																											; Funktion anspringen: StarWarsImageToggleShow(9)
		Case 121																																; Case: ASCII Code 121 - Key F10
			$sCW_Text = "F10 Key was pressed"																									; Variable definieren: $sCW_Text
			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console
		; ##############################################################################################################################

		; Key A bis Z für den HiddenScreen Code ########################################################################################
		Case 65																																	; Case: ASCII Code 065 - Key A
			If $sHiddenScreenCode = "YOD" Then $sHiddenScreenCode &= "A"																		; If-Abfrage: Wurden die Tasten 'YOD' vorher gedrückt?
			If $sHiddenScreenCode <> "YODA" Then $sHiddenScreenCode = False																		; If-Abfrage: Bei Fehler $sHiddenScreenCode wieder verwerfen
		Case 66																																	; Case: ASCII Code 066 - Key B
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 67																																	; Case: ASCII Code 067 - Key C
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 68																																	; Case: ASCII Code 068 - Key D
			If $sHiddenScreenCode = "YO" Then $sHiddenScreenCode &= "D"																			; If-Abfrage: Wurden die Tasten 'YO' vorher gedrückt?
			If $sHiddenScreenCode <> "YOD" Then $sHiddenScreenCode = False																		; If-Abfrage: Bei Fehler $sHiddenScreenCode wieder verwerfen
		Case 69																																	; Case: ASCII Code 069 - Key E
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 70																																	; Case: ASCII Code 070 - Key F
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 71																																	; Case: ASCII Code 071 - Key G
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 72																																	; Case: ASCII Code 072 - Key H
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 73																																	; Case: ASCII Code 073 - Key I
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 74																																	; Case: ASCII Code 074 - Key J
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 75																																	; Case: ASCII Code 075 - Key K
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 76																																	; Case: ASCII Code 076 - Key L
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 77																																	; Case: ASCII Code 077 - Key M
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 78																																	; Case: ASCII Code 078 - Key N
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 79																																	; Case: ASCII Code 079 - Key O
			If $sHiddenScreenCode = "Y" Then $sHiddenScreenCode &= "O"																			; If-Abfrage: Wurde die Taste Y vorher gedrückt?
			If $sHiddenScreenCode <> "YO" Then $sHiddenScreenCode = False																		; If-Abfrage: Bei Fehler $sHiddenScreenCode wieder verwerfen
		Case 80																																	; Case: ASCII Code 080 - Key P
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 81																																	; Case: ASCII Code 081 - Key Q
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 82																																	; Case: ASCII Code 082 - Key R
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 83																																	; Case: ASCII Code 083 - Key S
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 84																																	; Case: ASCII Code 084 - Key T
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 85																																	; Case: ASCII Code 085 - Key U
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 86																																	; Case: ASCII Code 086 - Key V
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 87																																	; Case: ASCII Code 087 - Key W
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 88																																	; Case: ASCII Code 088 - Key X
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		Case 89																																	; Case: ASCII Code 089 - Key Y
			$sHiddenScreenCode = "Y"																											; Variable definieren: $sHiddenScreenCode mit "Y" füllen
		Case 90																																	; Case: ASCII Code 090 - Key Z
			$sHiddenScreenCode = False																											; Variable definieren: $sHiddenScreenCode wieder auf "False" setzen
		; ##############################################################################################################################

	EndSwitch																																	; Ende der Switch-Abfrage: Welche Taste wurde gedrückt?

;~ 	$sCW_Text = "HiddenScreenCode: " & $sHiddenScreenCode																						; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

	If $sHiddenScreenCode = "YODA" Then HiddenScreen()																							; If-Abfrage: Funktion anspringen: Ist der HiddenScreenCode korrekt?
	If $iSW_Enable Then $iCT_SongNr = 0																											; If-Abfrage: Ist der Star Wars Modus aktiv, dann das Lied nicht wechseln
	If $iCT_SongActual <> $iCT_SongNr And $iCT_SongManual Then ManualChipTune()																	; If-Abfrage: Funktion anspringen: Ist der Manuelle Song Modus aktiv, dann Music Start/Pause
	$iKeyPressed = False																														; Variable definieren: $iKeyPressed wieder auf "FALSE" setzen
	GUIPush()																																	; Funktion anspringen: GUIPush

EndFunc																																			; Funktionsende: _Key_IsPressed

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _GUI_GetMsg
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _GUI_GetMsg()																																; Funktionsstart: _GUI_GetMsg

	Local $sCW_Text																																; Variable initialisieren

;~ 	$sCW_Text = "WinGetState: " & WinGetState ($hInfoFormGUI) & " - @GUI_CtrlId: " & @GUI_CtrlId												; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

	Switch @GUI_CtrlId																															; Switch-Abfrage: Welcher Event hat stattgefunden?

		Case $GUI_EVENT_CLOSE																													; Case: $GUI_EVENT_CLOSE

			If BitAND (WinGetState ($hInfoFormGUI), 8) Then $iInfoBoxExitButton = True															; If-Abfrage: Variable definieren

;~ 			$sCW_Text = "$GUI_EVENT_CLOSE" & @GUI_CtrlId																						; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $hExitImage																														; Case: $hExitImage

			$iInfoBoxExitButton = True																											; Variable definieren

;~ 			$sCW_Text = "$hExitImage" & @GUI_CtrlId																								; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $GUI_EVENT_MINIMIZE																												; Case: $GUI_EVENT_MINIMIZE

			$aAppStatus[0] = $iTextSlider																										; Variablen-Array definieren: $iTextSlider AppStatus merken
			$aAppStatus[1] = $iSW_Enable																										; Variablen-Array definieren: $iSW_Enable AppStatus merken
			$aAppStatus[2] = $iCT_SongManual																									; Variablen-Array definieren: $iCT_SongManual AppStatus merken

			If $iTextSlider Then ScrollStartStop()																								; If-Abfrage: Funktion anspringen: $iTextSlider Modus deaktivieren
			If $iSW_Enable Then StarWarsEnable()																								; If-Abfrage: Funktion anspringen: $iSW_Enable Modus deaktivieren
			If $iCT_SongManual Then ManualChipTune (True)																						; If-Abfrage: Funktion anspringen: $iCT_SongManual Modus deaktivieren

;~ 			$sCW_Text = "Before: $GUI_EVENT_MINIMIZE - TextSlider: " & $aAppStatus[0] & _														; Ausgabe Console: GUI Event (Teil 1)
;~ 												   " - StarWars: " & $aAppStatus[1] & _															; Ausgabe Console: GUI Event (Teil 2)
;~ 												   " - SongManual: " & $aAppStatus[2]															; Ausgabe Console: GUI Event (Teil 3)
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console
;~ 			$sCW_Text = "After:  $GUI_EVENT_MINIMIZE - TextSlider: " & $iTextSlider & _															; Ausgabe Console: GUI Event (Teil 1)
;~ 												   " - StarWars: " & $iSW_Enable & _															; Ausgabe Console: GUI Event (Teil 2)
;~ 												   " - SongManual: " & $iCT_SongManual															; Ausgabe Console: GUI Event (Teil 3)
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $GUI_EVENT_RESTORE																													; Case: $GUI_EVENT_RESTORE

			If $aAppStatus[0] And Not $iTextSlider Then ScrollStartStop()																		; If-Abfrage: Funktion anspringen: TextSlider Modus aktivieren wenn er vorher aktiv war
			If $aAppStatus[1] And Not $iSW_Enable Then StarWarsEnable()																			; If-Abfrage: Funktion anspringen: StarWars Modus aktivieren wenn er vorher aktiv war

			$aAppStatus[0] = False																												; Variable definieren: Wert fest auf "False" setzen
			$aAppStatus[1] = False																												; Variable definieren: Wert fest auf "False" setzen

			GUIPush()																															; Funktion anspringen: GUIPush

;~ 			$sCW_Text = "Before: $GUI_EVENT_RESTORE  - TextSlider: " & $iTextSlider & " - StarWars: " & $iSW_Enable								; Ausgabe Console: GUI Event
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console
;~ 			$sCW_Text = "After:  $GUI_EVENT_RESTORE  - TextSlider: " & $aAppStatus[0] & " - StarWars: " & $aAppStatus[1]						; Ausgabe Console: GUI Event
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $hMessage[1]																														; Case: $hMessage[1] - StarWarsImageToggleShow

			StarWarsImageToggleShow()																											; Funktion anspringen: Starwars Bild laden
			GUIPush()																															; Funktion anspringen: GUIPush

;~ 			$sCW_Text = "StarWarsImageToggleShow - ImageNr: " & $iSW_Image																		; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $hMessage[3]																														; Case: $hMessage[3] - StarWarsEnable

			StarWarsEnable()																													; Funktion anspringen: StarWars Modus aktivieren bzw. deaktivieren
			GUIPush()																															; Funktion anspringen: GUIPush

;~ 			$sCW_Text = "StarWarsEnable - StarWars: " & $iSW_Enable																				; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $hScrollLabel, $hLeftTowerImage, $hRightTowerImage																					; Case: $hScrollLabel, $hLeftTowerImage, $hRightTowerImage - ScrollStartStop

			ScrollStartStop()																													; Funktion anspringen: Scroller aktivieren bzw. deaktivieren
			GUIPush()																															; Funktion anspringen: GUIPush

;~ 			$sCW_Text = "$hScrollLabel, $hLeftTowerImage, $hRightTowerImage - TextSlider: " & $iTextSlider										; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case $hMessage[2], $hImageFile, $hVUL, $hVULTxt, $hVUR, $hVURTxt																		; Case: $hMessage[2], $hVUL, $hVULTxt, $hVUR, $hVURTxt, $hImageFile

			GUIPush()																															; Funktion anspringen: GUIPush

;~ 			$sCW_Text = "$hMessage[2], $hVUL, $hVULTxt, $hVUR, $hVURTxt, $hImageFile"															; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

		Case Else																																; Case Else
			
			GUIPush()																															; Funktion anspringen: GUIPush

			$sCW_Text = "Nicht definierter Event"																								; Variable definieren: $sCW_Text
			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

	EndSwitch																																	; Ende der Switch-Abfrage: Welcher Event hat stattgefunden?

EndFunc																																			; Funktionsende: _GUI_GetMsg

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: HiddenScreen
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func HiddenScreen()																																; Funktionsstart: HiddenScreen

	If $sCT_SongStatus = "playing" Then PauseChipTune()																							; If-Abfrage: Funktion anspringen: PlaySong Pause
	_Centered_Msgbox ("Congratulation!","You found the hidden code: " & @CRLF & @CRLF & $sHiddenScreenCode, "&OK", _							; Funktion anspringen: Zentrierte Messagebox mit zentriertem Text ausgeben (Teil 1)
					  $hInfoFormGUI, $sApplication_IconFile, 1, 180, 100, 50, 10)																; Funktion anspringen: Zentrierte Messagebox mit zentriertem Text ausgeben (Teil 2)
	If $sCT_SongStatus = "paused" Then PlayResumeChipTune()																						; If-Abfrage: Funktion anspringen: PlaySong Resume
	$sHiddenScreenCode = False																													; Variable definieren: $sHiddenScreenCode wieder verwerfen

EndFunc																																			; Funktionsende: HiddenScreen

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: AutoPlay (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func AutoPlay($hWnd, $iMsg, $iIDTimer, $iTime)																									; Funktionsstart: AutoPlay

	$iDO_ScrollPos = 0																															; Variable definieren: Start bei 0
	If Not $iTextSlider Then ScrollStartStop()																									; Variable definieren: Funktion anspringen: TextSlider aktivieren

EndFunc																																			; Funktionsende: AutoPlay

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _Chip_Music_INI
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _Chip_Music_INI ($sCM_FileName, $sCM_Sektion, $iCM_Nr)																						; Funktionsstart: _Chip_Music_INI

	Local $hCM_File = @ScriptDir & "\" & $sCM_FileName, $sCM_Data, $sCM_Read, $iCM_Count														; Lokale Variablen initialisieren

	$sCM_Data = IniRead ($hCM_File, $sCM_Sektion & $iCM_Nr, $sCM_Sektion, "Error")																; Variable definieren: Chip_Music.dat partiziell einlesen

	If $sCM_Data <> "Error" Then																												; If-Abfrage: Konnte die passende Sektion gefunden werden?

		For $iCM_Count = 1 To $sCM_Data																											; ForNext-Schleife: von 1 zu $sCM_Data (Anzahl der einzulesenden Zeilen)

			$sCM_Read &= IniRead ($hCM_File, $sCM_Sektion & $iCM_Nr, $sCM_Sektion & "_" & StringFormat ("%03i", $iCM_Count), "Error")			; Variable definieren: Chip_Music from File (Chip_Music.dat)

		Next																																	; Ende der ForNext-Schleife: von 1 zu $sCM_Data (Anzahl der einzulesenden Zeilen)

		$sCM_Read = _WinAPI_Base64Decode($sCM_Read)																								; Variable definieren: Daten aus der Chip_Music.dat durch _WinAPI_Base64Decode schicken
		If @error Then Return ("Error")																											; If-Abfrage: Bei Fehler "Error" zurück geben
		$sCM_Data = _ASM_DecompressLZMAT($sCM_Read)																								; Variable definieren: Daten aus der Chip_Music.dat durch _ASM_DecompressLZMAT
		If @error Then Return ("Error")																											; If-Abfrage: Bei Fehler "Error" zurück geben

	EndIf																																		; Ende der If-Abfrage: Konnte die passende Sektion gefunden werden?

	Return ($sCM_Data)																															; Inhalt zurück geben

EndFunc																																			; Funktionsende: _Chip_Music_INI

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: Load Chip Tune
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func LoadChipTune()																																; Funktionsstart: LoadChipTune

	Local $sCW_Text																																; Variable initialisieren

	_FSOUND_Init()																																; Funktion anspringen: Sound-Engine Init
	$CT_MEMLen = BinaryLen(Binary ($hCT_SongData))																								; Variable definieren: SongMEM-Länge ermitteln
	$CT_MEMData = DllStructCreate ("byte[" & $CT_MEMLen & "]")																					; Variable definieren: Struktur des Elements erstellen
	DllStructSetData ($CT_MEMData, 1, Binary ($hCT_SongData))																					; Setzt die Daten eines Elements in der Struktur
	$hSoundFile = _FMUSIC_LoadSongEx ($CT_MEMData, 0, $CT_MEMLen, $iFSOUND_LOADMEMORY)															; Variable definieren: Song-Handle erstellen
	$iCT_AllChannels = _FMUSIC_GetNumChannels ($hSoundFile)																						; Variable definieren: Song-Kanäle ermitteln
	$iCT_SongLength = _FMUSIC_GetNumOrders ($hSoundFile) - 1																					; Variable definieren: Song-Länge ermitteln
	$hCT_SongName = _StringProper (_FMUSIC_GetName ($hSoundFile))																				; Variable definieren: Song-Name ermitteln
	$iVolFadeOut = 100																															; Variable definieren: Volume auf 100%
	_FMUSIC_SetMasterVolume ($hSoundFile, $iVolFadeOut)																							; Funktion anspringen: Lautstärke setzen
	$sCT_SongStatus = "stopped"																													; Variable definieren: Song gestoppt

;~ 	$sCW_Text = "SongStatus: " & $sCT_SongStatus																								; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: LoadChipTune

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: Play / Resume Chip Tune
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func PlayResumeChipTune()																														; Funktionsstart: PlayResumeChipTune

	Local $sCW_Text																																; Variable initialisieren

	If $sCT_SongStatus = "stopped" Then																											; If-Abfrage: PlaySong Start, wenn Sound nicht gestartet

		_FMUSIC_PlaySong($hSoundFile)																											; Funktion anspringen: Song abspielen
		$sCT_SongStatus = "playing"																												; Variable definieren

	ElseIf $sCT_SongStatus = "paused" Then																										; ElseIf-Abfrage: PlaySong Resume, wenn Sound pausiert

		_FMUSIC_PauseSong($hSoundFile, 0)																										; Funktion anspringen: Song resume
		$sCT_SongStatus = "playing"																												; Variable definieren

	EndIf																																		; Ende der If-Abfrage: PlaySong Start, wenn Sound nicht gestartet

;~ 	$sCW_Text = "SongStatus: " & $sCT_SongStatus																								; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: PlayResumeChipTune

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: Pause Chip Tune
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func PauseChipTune()																															; Funktionsstart: PauseChipTune

	Local $sCW_Text																																; Variable initialisieren

	If $sCT_SongStatus = "playing" Then																											; If-Abfrage: PlaySong Pause

		_FMUSIC_PauseSong($hSoundFile, 1)																										; Funktion anspringen: Song pausieren
		$sCT_SongStatus = "paused"																												; Variable definieren

	EndIf																																		; Ende der If-Abfrage: PlaySong Pause

;~ 	$sCW_Text = "SongStatus: " & $sCT_SongStatus																								; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: PauseChipTune

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: Toggle Chip Tune
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func ToggleChipTune()																															; Funktionsstart: ToggleChipTune

	Local $sCW_Text																																; Variable initialisieren

	If $iCT_SongManual Or $iTextSlider Or $iSW_Enable Then																						; If-Abfrage: Welcher Modus aktiv?

		If $iCT_SongActual <> $iCT_SongNr Then																									; If-Abfrage: Ist der falsche Song noch aktiv?

			$hCT_SongData = $ah_ChipMusicMEM[$iCT_SongNr]																						; Variable definieren: Song-Data aus MEM holen
			If $hCT_SongData <> "Error" Then LoadChipTune()																						; If-Abfrage: Funktion anspringen: Chip Tune laden
			If $hCT_SongData <> "Error" Then $iCT_SongActual = $iCT_SongNr																		; If-Abfrage: Variable definieren
			If $hCT_SongData = "Error" Then $iCT_SongNr = $iCT_SongActual																		; If-Abfrage: Variable definieren

			PlayResumeChipTune()																												; Funktion anspringen: PlaySong Play oder Resume

		EndIf																																	; Ende der If-Abfrage: Ist der falsche Song noch aktiv?

		If Not $iCT_SongManual And $iTextSlider Then PlayResumeChipTune()																		; If-Abfrage: Funktion anspringen: PlaySong Play oder Resume
		If Not $iCT_SongManual And $iSW_Enable Then PlayResumeChipTune()																		; If-Abfrage: Funktion anspringen: PlaySong Play oder Resume

	EndIf																																		; Ende der If-Abfrage: Welcher Modus aktiv?

	If Not $iCT_SongManual And Not $iTextSlider And Not $iSW_Enable Then PauseChipTune()														; If-Abfrage: Funktion anspringen: PlaySong Pause

;~ 	$sCW_Text = "SM: " & $iCT_SongManual & " - TS: " & $iTextSlider & " - SW: " & $iSW_Enable & " - ST: " & $sCT_SongStatus						; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: ToggleChipTune

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: Manual Play/Pause Chip Tune
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func ManualChipTune($iCT_ChangeStatus = False)																									; Funktionsstart: ManualChipTune

	Local $sCW_Text																																; Variable initialisieren

	If $iCT_ChangeStatus Then $iCT_SongManual = Not $iCT_SongManual																				; Variable definieren: Musik wurde manuell gestartet

	If $iCT_SongManual Then																														; If-Abfrage: Ist der manuelle Song Modus aktiv?

		If $iCT_SongActual <> $iCT_SongNr Then																									; If-Abfrage: Ist der falsche Song noch aktiv?

;~ 			$sCW_Text = "SW: " & $iSW_Enable & " - ST: " & $sCT_SongStatus & " - SA: " & $iCT_SongActual & " - SN: " & $iCT_SongNr				; Variable definieren: $sCW_Text
;~ 			_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																						; Funktion anspringen: Ausgabe Console

			$hCT_SongData = $ah_ChipMusicMEM[$iCT_SongNr]																						; Variable definieren: Song-Data aus MEM holen
			If $hCT_SongData <> "Error" Then																									; If-Abfrage: Wenn in $hCT_SongData kein "Error" steht

				LoadChipTune()																													; Funktion anspringen: Chip Tune laden
				$iCT_SongActual = $iCT_SongNr																									; Variable definieren

			ElseIf $hCT_SongData = "Error" Then 																								; ElseIf-Abfrage: Wenn in $hCT_SongData "Error" steht

				$iCT_SongNr = $iCT_SongActual																									; Variable definieren

			EndIf																																; Ende der If-Abfrage: Wenn in $hCT_SongData kein "Error" steht

			PlayResumeChipTune()																												; Funktion anspringen: PlaySong Play oder Resume

		Else																																	; Else-Abfrage: Ist der falsche Song noch aktiv?

			If $sCT_SongStatus = "playing" Then																									; If-Abfrage: Ist der Song aktiv?

				PauseChipTune()																													; Funktion anspringen: PlaySong Pause

			ElseIf $sCT_SongStatus = "paused" Then																								; ElseIf-Abfrage: Ist der Song inaktiv?

				PlayResumeChipTune()																											; Funktion anspringen: PlaySong Play oder Resume

			EndIf																																; Ende der If-Abfrage: Ist der Song aktiv?

		EndIf																																	; Ende der If-Abfrage: Ist der falsche Song noch aktiv?

	EndIf																																		; Ende der If-Abfrage: Ist der manuelle Song Modus aktiv?

EndFunc																																			; Funktionsende: ManualChipTune

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: VUMeterShufflePlayPause (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func VUMeterShufflePlayPause($hWnd, $iMsg, $iIDTimer, $iTime)																					; Funktionsstart: VUMeterShufflePlayPause

	Local $iAdLibTimer = TimerInit(), $sCW_Text																									; Lokale Variable definieren: AdLib TimerInit

	Local Static $iLeftChannel, $iRightChannel, $aChannels, $iCT_CurrentChannel																	; Lokale statische Variable initialisieren
	Local Static $iPowerL, $iPowerR, $iRed, $iGreen, $hVULTxtBufferOld, $hVURTxtBufferOld														; Lokale statische Variable initialisieren
	
	If $sCT_SongStatus = "playing" Then																											; If-Abfrage: VUMeter anzeigen, wenn Sound spielt

		Local $iCT_ActualPattern = _FMUSIC_GetOrder($hSoundFile)																				; Lokale Variable initialisieren

		If $iCT_SongLength - $iCT_ActualPattern <= 0 Then $iCT_Complete = True																	; If-Abfrage: Ist der letzte Track aktiv?

		$iLeftChannel = 0																														; Variable setzen
		$iRightChannel = 0																														; Variable setzen

		For $iCT_CurrentChannel = 1 To $iCT_AllChannels																							; ForNext-Schleife: Wieviele Kanäle gibt es?

			$aChannels = _FSOUND_GetCurrentLevels($iCT_CurrentChannel)																			; Variable definieren: Aktuellen Channel Level holen
			$iLeftChannel += $aChannels[0]																										; Variable setzen
			$iRightChannel += $aChannels[1]																										; Variable setzen

		Next																																	; Ende der ForNext-Schleife: Wieviele Kanäle gibt es?

		$iPowerL = Int($iLeftChannel / $iCT_AllChannels * $iGUI_Width / 4)																		; Variable setzen
		$iPowerR = Int($iRightChannel / $iCT_AllChannels * $iGUI_Width / 4)																		; Variable setzen

		GUICtrlSetData ($hVUL, _StringRepeat (ChrW(0x25A0), $iPowerL))																			; VU-Meter erzeugen
		GUICtrlSetData ($hVUR, _StringRepeat (ChrW(0x25A0), $iPowerR))																			; VU-Meter erzeugen

		Local $fLZ = "00", $fProgress = StringFormat ("%.2f %", $iCT_ActualPattern / $iCT_SongLength * 100)										; Lokale Variable initialisieren: Song Status in Prozent mit zwei Leading Zero, wenn 1-stellig
		If $fProgress >= 10 Then $fLZ = "0"																										; If-Abfrage: Variable definieren: eine LZ, wenn 2-stellig
		If $fProgress >= 100 Then $fLZ = ""																										; If-Abfrage: Variable definieren: keine LZ, wenn 3-stellig
		
		Local $hVULTxtBuffer = "No." & StringFormat (" %02d ", $iCT_SongNr) & _																	; VU-Meter Text Buffer erzeugen (Teil 1)
							   "- Ch." & StringFormat (" %02d ", $iCT_AllChannels) & _															; VU-Meter Text Buffer erzeugen (Teil 2)
							   "- Trk." & StringFormat (" %02d", $iCT_ActualPattern) & "/" & StringFormat ("%02d ", $iCT_SongLength) & _		; VU-Meter Text Buffer erzeugen (Teil 3)
							   "- " & $fLZ & $fProgress																							; VU-Meter Text Buffer erzeugen (Teil 4)
		Local $hVURTxtBuffer = "Title: " & $hCT_SongName																						; VU-Meter Text Buffer erzeugen

		If $hVULTxtBuffer <> $hVULTxtBufferOld Then GUICtrlSetData ($hVULTxt, $hVULTxtBuffer)													; VU-Meter Text erzeugen
		If $hVURTxtBuffer <> $hVURTxtBufferOld Then GUICtrlSetData ($hVURTxt, $hVURTxtBuffer)													; VU-Meter Text erzeugen

		GUICtrlSetColor ($hVULTxt, 0xEEEEEE)																									; VU-Meter Text sichtbar machen
		GUICtrlSetColor ($hVURTxt, 0xEEEEEE)																									; VU-Meter Text sichtbar machen

		$hVULTxtBufferOld = $hVULTxtBuffer																										; Variable definieren
		$hVURTxtBufferOld = $hVURTxtBuffer																										; Variable definieren

		$iRed = 0x10 + $iPowerL * 16																											; Variable setzen
		$iRed = $iRed > 0xFF ? 0xFF : $iRed																										; Variable setzen
		$iGreen = 0xD0 - $iPowerL * 10																											; Variable setzen
		$iGreen = $iGreen < 0 ? 0 : $iGreen																										; Variable setzen
		GUICtrlSetColor($hVUL, BitShift($iRed, -16) + BitShift($iGreen, -8) + 0x30)																; Farbe des Labels setzen

		$iRed = 0x10 + $iPowerR * 16																											; Variable setzen
		$iRed = $iRed > 0xFF ? 0xFF : $iRed																										; Variable setzen
		$iGreen = 0xD0 - $iPowerR * 10																											; Variable setzen
		$iGreen = $iGreen < 0 ? 0 : $iGreen																										; Variable setzen
		GUICtrlSetColor($hVUR, BitShift($iRed, -16) + BitShift($iGreen, -8) + 0x30)																; Farbe des Labels setzen

	EndIf																																		; Ende der If-Abfrage: VUMeter anzeigen, wenn Sound spielt

	$aVM_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aVM_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

  	If $iDebugTimer Then $sCW_Text = "Elepsaed time within VUMeterShufflePlayPause: " & TimerDiff ($iAdLibTimer)								; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: VUMeterShufflePlayPause

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: VUMeterVolFadeOut
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func VUMeterVolFadeOut()																														; Funktionsstart: VUMeterVolFadeOut

	Local $sCW_Text																																; Lokale Variable initialisieren

	If $sCT_SongStatus = "playing" Then																											; If-Abfrage: Volume ausfaden und VUMeter ausblenden, wenn Sound zu ende

		If $iCT_Complete Then																													; If-Abfrage: Wenn das aktuelle Lied zu über 90% fertig ist, dann FadeOut

			If $iVolFadeOut > 0 Then 																											; If-Abfrage: Soll das nächste Lied automatisch gestartet werden?
			
				$iVolFadeOut -= 3																												; Variable definieren: Wenn Lautstärke noch größer 0 dann um 1 verringern
				_FMUSIC_SetMasterVolume($hSoundFile, $iVolFadeOut)																				; Funktion anspringen: Lautstärke setzen
				Sleep (1)																														; 1ms Pause

			ElseIf $iVolFadeOut < 1 Then																										; ElseIf-Abfrage: Soll das nächste Lied automatisch gestartet werden?

				_FMUSIC_StopSong($hSoundFile)																									; Funktion anspringen: StopSong
				$sCT_SongStatus = "stopped"																										; Variable definieren: Song gestoppt
				$iCT_Complete = False																											; Variable definieren: Wert fest auf "False" setzen
				$iVolFadeOut = 100																												; Variable definieren: Volume auf 100%
				$iCT_SongActual = 99																											; Variable definieren: Reload des Song erzwingen
				$iCT_SongNr += 1																												; Variable definieren: Wert um 1 erhöhen
				If $iCT_SongNr > $iCT_SongsMax Then $iCT_SongNr = 1																				; If-Abfrage: Ende der Lieder erreicht?
				If $iSW_Enable Then StarWarsEnable()																							; If-Abfrage: Funktion anspringen: StarWars deaktivieren
			
			EndIf																																; Ende der If-Abfrage: Soll das nächste Lied automatisch gestartet werden?

		EndIf																																	; Ende der If-Abfrage: Wenn das aktuelle Lied zu über 90% fertig ist, dann FadeOut																																	; If-Abfrage: Ist das aktuelle Lied zu über 90% fertig?

;~ 		$sCW_Text = $iCT_Complete & " - " & $iVolFadeOut & " - " & $iCT_SongNr & " - " & $sCT_SongStatus										; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

	ElseIf $sCT_SongStatus = "paused" Or $sCT_SongStatus = "stopped" Then																		; ElseIf-Abfrage: VUMeter löschen, wenn Sound pausiert oder gestoppt ist
		
		GUICtrlSetData ($hVUL, "")																												; VU-Meter löschen
		GUICtrlSetData ($hVUR, "")																												; VU-Meter löschen
		GUICtrlSetColor ($hVULTxt, 0x000000)																									; VU-Meter Text unsichtbar machen
		GUICtrlSetColor ($hVURTxt, 0x000000)																									; VU-Meter Text unsichtbar machen

	EndIf																																		; Ende der If-Abfrage: Volume ausfaden und VUMeter löschen, wenn Sound zu ende

EndFunc																																			; Funktionsende: VUMeterVolFadeOut

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: InfoScrollScrollStartStop
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func ScrollStartStop()																															; Funktionsstart: InfoScrollScrollStartStop

	$iTextSlider = Not $iTextSlider																												; Variable definieren: Wechsel zwischen "True" und "False"

	$iColorDefault = False																														; Variable definieren: Fest auf "False" setzen
	$iCT_SongManual = False																														; Variable definieren: Manuellen Song-Play wieder abschalten

	_Timer_KillTimer ($hInfoFormGUI, $hTimerAutoPlay)																							; _Timer_KillTimer: Funktion AutoPlay deaktivieren

	$TogglePlay = TimerInit()																													; Variable definieren: TogglePlay
	$ToggleEffekt = 0																															; Variable definieren: Effekt auf Anfang
	
	If BitAND (WinGetState ($hInfoFormGUI), 8) Then GUIPush()																					; If-Abfrage: Funktion anspringen: GUIPush

EndFunc																																			; Funktionsende: InfoScrollScrollStartStop

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: GUIPush
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func GUIPush()																																	; Funktionsstart: GUIPush

	GUISetState (@SW_RESTORE, $hLeftTowerGUI)																									; LeftTower-GUI anzeigen
	GUISetState (@SW_RESTORE, $hRightTowerGUI)																									; RightTower-GUI anzeigen
	
	Select 																																		; Select-Abfrage
		
		Case $iSW_Enable																														; Case: Ist der Star Wars Modus an?
		
			GUISetState (@SW_SHOW, $hImageGUI)																									; Image-GUI anzeigen
			GUISetState (@SW_RESTORE, $hImageGUI)																								; Image-GUI in der Vordergrund holen
			GUISetState (@SW_HIDE, $hFontFormerGUI)																								; FontFormer-GUI ausblenden
	
		Case Not $iSW_Enable																													; Case: Ist der Star Wars Modus aus?
	
			GUISetState (@SW_HIDE, $hImageGUI)																									; Image-GUI ausblenden
			GUISetState (@SW_SHOW, $hFontFormerGUI)																								; FontFormer-GUI anzeigen
		
	EndSelect																																	; Ende der Select-Abfrage

	GUISetState (@SW_RESTORE, $hInfoFormGUI)																									; Info-GUI wieder in den Focus holen
	GUISwitch($hInfoFormGUI)																													; Info-GUI - hier spielt die Musik

EndFunc																																			; Funktionsende: GUIPush

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: EffectsRotate, ToggleEffekt und Musik
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func EffectsRotate ($hFT_Context, $hFT_FooterFont, $aFT_Rectf, $hFT_Format, $hFT_Brush, $hFT_Graphics, $hFT_Bitmap, _							; Funktionsstart: EffectsRotate (Teil 1)
					$sForceText, $iFooter, $aLabelHeight, $ER_ScrollPos)																			; Funktionsstart: EffectsRotate (Teil 2)

	If $iTextSlider Then																														; If-Abfrage: Bewegt sich das Label?

		; Headline #####################################################################################################################
		$aColRot[0] = BitRotate ($aColRot[0], 1, "D")																							; Variablen-Array definieren: BitRotate
		$hFW_Pen = _GDIPlus_PenCreate("0xFF" & Hex ($aColRot[0], 6), 2)																			; GDIPlus: Stiftobjekt erstellen und Farbe setzen
		_GDIPlus_GraphicsDrawImage($hFW_Graphics, $hFW_Bitmap, 0, 0)																			; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle
		; ##############################################################################################################################

		; FontFormer ###################################################################################################################
		$aColRot[2] = BitRotate ($aColRot[2], 1, "D")																							; Variablen-Array definieren: BitRotate
		GUICtrlSetColor ($hMessage[2], "0x" & Hex ($aColRot[2], 6))																				; Farbe des Labels setzen
		; ##############################################################################################################################

		; Footer #######################################################################################################################
		$aColRot[1] = BitRotate ($aColRot[1], 1, "D")																							; Variablen-Array definieren: BitRotate
		$aColRot[3] = BitRotate ($aColRot[3], 1, "D")																							; Variablen-Array definieren: BitRotate
		$hFT_Brush = _GDIPlus_BrushCreateSolid("0xFF" & Hex ($aColRot[3], 6))																	; Farbe des Labels setzen
		_GDIPlus_GraphicsClear ($hFT_Context, "0xFF" & Hex ($aColRot[1], 6))																	; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
		_GDIPlus_GraphicsDrawStringEx ($hFT_Context, $sForceText, $hFT_FooterFont, $aFT_Rectf, $hFT_Format, $hFT_Brush)							; GDIPlus: String zeichnen
		_GDIPlus_GraphicsDrawImageRect ($hFT_Graphics, $hFT_Bitmap, 0, 0, $iGUI_Width, $aLabelHeight[$iFooter])									; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle
		; ##############################################################################################################################

		If Not $iSW_Enable Then																													; If-Abfrage: Ist der StarWarsModus aktiv?

			Switch $ToggleEffekt																												; Switch-Abfrage: Welcher Effekt soll dargestellt werden?

				Case 0																															; Effekt 0 darstellen

					GUICtrlSetFont ($hMessage[2], 12, $FW_HEAVY, 0, "Arial")																	; Font des Labels setzen
					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					WinMove ($hFontFormerGUI, "", $aInfoFormPos[0], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI wieder normal positionieren
					$ToggleEffekt += 1																											; Variable definieren: Wert um 1 erhöhen

				Case 1																															; Effekt 1 darstellen

					TogglePlay(5)																												; Funktion anspringen: TogglePlay

				Case 2																															; Effekt 2 darstellen

					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					$aMoveGUIPos[2] = $iGUI_Width / 2																							; Variablen-Array definieren: festgelegte X-Pos der FontFormer-GUI
					$aMoveGUIPos[3] = ($aInfoFormPos[0] - ($ER_ScrollPos / 2))																	; Variablen-Array definieren: errechnete X-Pos der FontFormer-GUI
					WinMove ($hFontFormerGUI, "", $aMoveGUIPos[3], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI entgegen des Scrollers bewegen
					TogglePlay(8)																												; Funktion anspringen: TogglePlay

				Case 3																															; Effekt 3 darstellen

					GUICtrlSetFont ($hMessage[2], 12, $FW_HEAVY, 0, "Arial")																	; Font des Labels setzen
					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					WinMove ($hFontFormerGUI, "", $aInfoFormPos[0], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI wieder normal positionieren
					$ToggleEffekt += 1																											; Variable definieren: Wert um 1 erhöhen

				Case 4																															; Effekt 4 darstellen

					TogglePlay(2)																												; Funktion anspringen: TogglePlay

				Case 5																															; Effekt 5 darstellen

					_GuiCtrlSetFont($hMessage[2], 16, $ER_ScrollPos * 10, $FW_HEAVY, 0, 2, "Franklin Gothic Medium")							; Neues FontObjekt ersellen
					TogglePlay(12)																												; Funktion anspringen: TogglePlay

				Case 6																															; Effekt 6 darstellen

					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					$aMoveGUIPos[2] = $iGUI_Width / 2																							; Variablen-Array definieren: festgelegte X-Pos der FontFormer-GUI
					$aMoveGUIPos[3] = ($aInfoFormPos[0] - ($ER_ScrollPos))																		; Variablen-Array definieren: errechnete X-Pos der FontFormer-GUI
					WinMove ($hFontFormerGUI, "", $aMoveGUIPos[3], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI entgegen des Scrollers bewegen
					_GuiCtrlSetFont($hMessage[2], 16, $ER_ScrollPos * 10, $FW_HEAVY, 0, 2, "Franklin Gothic Medium")							; Neues FontObjekt ersellen
					TogglePlay(10)																												; Funktion anspringen: TogglePlay

				Case 7																															; Effekt 7 darstellen

					GUICtrlSetFont ($hMessage[2], 12, $FW_HEAVY, 0, "Arial")																	; Font des Labels setzen
					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					WinMove ($hFontFormerGUI, "", $aInfoFormPos[0], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI wieder normal positionieren
					$ToggleEffekt += 1																											; Variable definieren: Wert um 1 erhöhen

				Case 8																															; Effekt 8 darstellen

					TogglePlay(2)																												; Funktion anspringen: TogglePlay

				Case 9																															; Effekt 9 darstellen

					GUICtrlSetFont ($hMessage[2], Abs ($ER_ScrollPos / 6) + 5, $FW_HEAVY, 0, "Arial")											; Font des Labels setzen
					TogglePlay(6.5)																												; Funktion anspringen: TogglePlay

				Case 10																															; Effekt 10 darstellen

					_GuiCtrlSetFont($hMessage[2], Abs ($ER_ScrollPos / 4) + 5, $ER_ScrollPos, $FW_HEAVY, 0, 2, "Arial")							; Neues FontObjekt ersellen
					TogglePlay(8)																												; Funktion anspringen: TogglePlay

				Case 11																															; Effekt 11 darstellen

					$aInfoFormPos = WinGetPos($hInfoFormGUI)																					; Position der Haupt-GUI ermitteln
					$aMoveGUIPos[2] = $iGUI_Width / 2																							; Variablen-Array definieren: festgelegte X-Pos der FontFormer-GUI
					$aMoveGUIPos[3] = ($aInfoFormPos[0] - ($ER_ScrollPos * 2))																	; Variablen-Array definieren: errechnete X-Pos der FontFormer-GUI
					WinMove ($hFontFormerGUI, "", $aMoveGUIPos[3], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)							; FontFormer-GUI entgegen des Scrollers bewegen
					_GuiCtrlSetFont($hMessage[2], Abs ($ER_ScrollPos / 4) + 5, $ER_ScrollPos, $FW_HEAVY, 0, 2, "Arial")							; Neues FontObjekt ersellen
					TogglePlay(6.5)																												; Funktion anspringen: TogglePlay

			EndSwitch																															; Ende der Switch-Abfrage: Weclher Effekt soll dargestellt werden?

		EndIf																																	; Ende der If-Abfrage: Ist der StarWarsModus aktiv?

	ElseIf Not $iTextSlider Then																												; ElseIf-Abfrage: Bewegt sich das Label?

		If Not $iColorDefault Then																												; If-Abfrage: Sind die Label Farben wieder auf Default?

			; Headline #################################################################################################################
			_GDIPlus_GraphicsClear ($hFW_Context, 0xFF000000)																					; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
			$hFW_Pen = _GDIPlus_PenCreate (0xFFFF0000, 2)																						; GDIPlus: Stiftobjekt erstellen und Farbe setzen

			For $i = 1 To $pFW_IterCnt																											; ForNext-Schleife: FontWobbler erstellen

				_GDIPlus_PathReset ($hFW_SubPath)																								; GDIPlus: Leert einen Pfad und legt den Füllmodus abwechselnd fest
				_GDIPlus_PathIterNextSubpathPath ($pFW_Iter, $hFW_SubPath)																		; GDIPlus: Ruft die nächste Abbildung (Unterpfad) aus dem Iterator zugeordneten Pfad ab
				$aFW_Bounds = _GDIPlus_PathGetWorldBounds ($hFW_SubPath)																		; Variable definieren: GDIPlus: Ruft das umrandete Rechteck für einen Pfad ab
				_GDIPlus_MatrixSetElements ($hFW_Matrix, 1, 0, 0, 1, 0, 0)																		; GDIPlus: Setzt die Elemente einer Matrix
				_GDIPlus_MatrixTranslate ($hFW_Matrix, -($aFW_Bounds[0] + $aFW_Bounds[2] / 2), -($aFW_Bounds[1] + $aFW_Bounds[3] / 2))			; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Übersetzungsmatrix
				_GDIPlus_MatrixRotate ($hFW_Matrix, Random (-24, 24), True)																		; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Rotationsmatrix
				_GDIPlus_MatrixTranslate ($hFW_Matrix, $aFW_Bounds[0] + $aFW_Bounds[2] / 2, $aFW_Bounds[1] + $aFW_Bounds[3] / 2, True)			; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Übersetzungsmatrix
				_GDIPlus_PathTransform ($hFW_SubPath, $hFW_Matrix)																				; GDIPlus: Multipliziert jeden Datenpunkt eines Pfades mit einer angegebenen Matrix
				_GDIPlus_GraphicsDrawPath ($hFW_Context, $hFW_SubPath, $hFW_Pen)																; GDIPlus: Zeichnet eine Folge von Linien und Kurven, die von einem GraphicsPath-Objekt definiert werden

			Next																																; Ende der ForNext-Schleife: FontWobbler erstellen

			_GDIPlus_PathIterRewind ($pFW_Iter)																									; GDIPlus: Setzt einen Iterator an den Anfang des zugehörigen Pfads zurück
			_GDIPlus_GraphicsDrawImage ($hFW_Graphics, $hFW_Bitmap, 0, 0)																		; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle
			; ##########################################################################################################################

			; FontFormer ###############################################################################################################
			$aInfoFormPos = WinGetPos($hInfoFormGUI)																							; Position der Haupt-GUI ermitteln
			WinMove ($hFontFormerGUI, "", $aInfoFormPos[0], $aInfoFormPos[1] + $aLabelYPos[$iFontFormer] + 26)									; FontFormer-GUI wieder normal positionieren
			GUICtrlSetColor ($hMessage[2], 0xEEEEEE)																							; Farbe des Labels setzen
			GUICtrlSetFont ($hMessage[2], 12, $FW_HEAVY, 0, "Arial")																			; Font des Labels setzen
			; ##########################################################################################################################

			; Footer ###################################################################################################################
			$hFT_Brush = _GDIPlus_BrushCreateSolid (0xFF999999)																					; Farbe des Labels setzen
			_GDIPlus_GraphicsClear ($hFT_Context, 0xFF000000)																					; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
			_GDIPlus_GraphicsDrawStringEx ($hFT_Context, $sForceText, $hFT_FooterFont, $aFT_Rectf, $hFT_Format, $hFT_Brush)						; GDIPlus: String zeichnen
			_GDIPlus_GraphicsDrawImageRect ($hFT_Graphics, $hFT_Bitmap, 0, 0, $iGUI_Width, $aLabelHeight[$iFooter])								; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle
			; ##########################################################################################################################

			$iColorDefault = True																												; Variable definieren: Fest auf "True" setzen

		EndIf																																	; Ende der If-Abfrage: Sind die Label Farben wieder auf Default?

	EndIf																																		; Ende der If-Abfrage: Bewegt sich das Label?

	$aER_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aER_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

EndFunc																																			; Funktionsende: EffectsRotate

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: TogglePlay
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func TogglePlay($Time = 10)																														; Funktionsstart: TogglePlay

	If TimerDiff ($TogglePlay) > $Time * 1000 Then																								; If-Abfrage: Soll der nächste Effekt automatisch gestartet werden?

		$ToggleEffekt += 1																														; Variable definieren: Wert um 1 erhöhen
		If $ToggleEffekt > 11 Then $ToggleEffekt = 0																							; If-Abfrage: Ende der Effekte erreicht?
		$TogglePlay = TimerInit()																												; Variable definieren: TogglePlay TimerInit

	EndIf																																		; Ende der If-Abfrage: Soll der nächste Effekt automatisch gestartet werden?

EndFunc																																			; Funktionsende: TogglePlay

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: FontWobbler (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func FontWobbler($hWnd, $iMsg, $iIDTimer, $iTime)																								; Funktionsstart: FontWobbler

	Local $iAdLibTimer = TimerInit(), $sCW_Text																									; Lokale Variable definieren: AdLib TimerInit

	If $iTextSlider Then																														; If-Abfrage: Bewegt sich der TextSlider?

		_GDIPlus_GraphicsClear($hFW_Context, 0xFF000000)																						; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe

		For $i = 1 To $pFW_IterCnt																												; ForNext-Schleife: FontWobbler erstellen

			_GDIPlus_PathReset ($hFW_SubPath)																									; GDIPlus: Leert einen Pfad und legt den Füllmodus abwechselnd fest
			_GDIPlus_PathIterNextSubpathPath ($pFW_Iter, $hFW_SubPath)																			; GDIPlus: Ruft die nächste Abbildung (Unterpfad) aus dem Iterator zugeordneten Pfad ab
			$aFW_Bounds = _GDIPlus_PathGetWorldBounds ($hFW_SubPath)																			; Variable definieren: GDIPlus: Ruft das umrandete Rechteck für einen Pfad ab
			_GDIPlus_MatrixSetElements ($hFW_Matrix, 1, 0, 0, 1, 0, 0)																			; GDIPlus: Setzt die Elemente einer Matrix
			_GDIPlus_MatrixTranslate ($hFW_Matrix, -($aFW_Bounds[0] + $aFW_Bounds[2] / 2), -($aFW_Bounds[1] + $aFW_Bounds[3] / 2))				; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Übersetzungsmatrix
			_GDIPlus_MatrixRotate ($hFW_Matrix, Random (-44, 44), True)																			; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Rotationsmatrix
			_GDIPlus_MatrixTranslate ($hFW_Matrix, $aFW_Bounds[0] + $aFW_Bounds[2] / 2, $aFW_Bounds[1] + $aFW_Bounds[3] / 2, True)				; GDIPlus: Aktualisiert eine Matrix mit dem Produkt von sich selbst und einer Übersetzungsmatrix
			_GDIPlus_PathTransform ($hFW_SubPath, $hFW_Matrix)																					; GDIPlus: Multipliziert jeden Datenpunkt eines Pfades mit einer angegebenen Matrix
			_GDIPlus_GraphicsDrawPath ($hFW_Context, $hFW_SubPath, $hFW_Pen)																	; GDIPlus: Zeichnet eine Folge von Linien und Kurven, die von einem GraphicsPath-Objekt definiert werden

		Next																																	; Ende der ForNext-Schleife: FontWobbler erstellen

		_GDIPlus_PathIterRewind ($pFW_Iter)																										; GDIPlus: Setzt einen Iterator an den Anfang des zugehörigen Pfads zurück

	EndIf																																		; Ende der If-Abfrage: Bewegt sich der TextSlider und ist Star Wars aus?

	$aFW_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aFW_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

  	If $iDebugTimer Then $sCW_Text = "Elepsaed time within FontWobbler: " & TimerDiff ($iAdLibTimer)											; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: FontWobbler

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: TextSlider (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func TextSlider($hWnd, $iMsg, $iIDTimer, $iTime)																								; Funktionsstart: TextSlider

	Local $iAdLibTimer = TimerInit(), $sCW_Text																									; Lokale Variable definieren: AdLib TimerInit

	Local Static $TS_LoopSwitch = True, $TS_ScrollPos = 0																						; Lokale Static Variablen initialisieren und definieren
	Local $TS_Len = $iGUI_Width / 5, $TS_ScrollPosStep = 4																						; Lokale Variablen initialisieren

	If $iTextSlider And Not $iSW_Enable Then																									; If-Abfrage: Bewegt sich der TextSlider und ist Star Wars aus?

		If $TS_LoopSwitch Then $TS_ScrollPos += $TS_ScrollPosStep																				; If-Abfrage: Variable definieren: Welcher DoLoop Modus ist aktiv? 
		If Not $TS_LoopSwitch Then $TS_ScrollPos -= $TS_ScrollPosStep																			; If-Abfrage: Variable definieren: Welcher DoLoop Modus ist aktiv? 
		If $TS_ScrollPos > $TS_Len Or $TS_ScrollPos < -$TS_Len Then $TS_LoopSwitch = Not $TS_LoopSwitch											; If-Abfrage: Wechsel der Richtung

		_GDIPlus_GraphicsClear ($hST_Context, 0xFF00FF00)																						; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
		$aST_Rectf = _GDIPlus_RectFCreate ($TS_ScrollPos, 0, $sScrollTextLen, $aLabelHeight[$iScroller])										; Variable definieren: GDIPlus Struktur erstellen
		_GDIPlus_GraphicsDrawStringEx ($hST_Context, $sScrollText, $hST_ScrollerFont, $aST_Rectf, $hST_Format, $hST_Brush)						; GDIPlus: String zeichnen
		_GDIPlus_GraphicsDrawImageRect ($hST_Graphics, $hST_Bitmap, 0, 0, $iGUI_Width - ($iScrollerXPos * 2), $aLabelHeight[$iScroller])		; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle

	ElseIf Not $iTextSlider And Not $iSW_Enable Then																							; ElseIf-Abfrage: Ist der TextSlider und Star Wars aus?

		$TS_ScrollPos = 0																														; Variable definieren
		
		_GDIPlus_GraphicsClear ($hST_Context, 0xFF00FF00)																						; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
		$aST_Rectf = _GDIPlus_RectFCreate ($TS_ScrollPos, 0, $sScrollTextLen, $aLabelHeight[$iScroller])										; Variable definieren: GDIPlus Struktur erstellen
		_GDIPlus_GraphicsDrawStringEx ($hST_Context, $sScrollText, $hST_ScrollerFont, $aST_Rectf, $hST_Format, $hST_Brush)						; GDIPlus: String zeichnen
		_GDIPlus_GraphicsDrawImageRect ($hST_Graphics, $hST_Bitmap, 0, 0, $sScrollTextLen, $aLabelHeight[$iScroller])							; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle (Teil 2)
			
	EndIf																																		; Ende der If-Abfrage: Bewegt sich der TextSlider und ist Star Wars aus?

	$aTS_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aTS_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

  	If $iDebugTimer Then $sCW_Text = "Elepsaed time within TextSlider: " & TimerDiff ($iAdLibTimer)												; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: TextSlider

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsScroller (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsScroller($hWnd, $iMsg, $iIDTimer, $iTime)																							; Funktionsstart: StarWarsScroller

	Local $iAdLibTimer = TimerInit(), $sCW_Text																									; Lokale Variable definieren: AdLib TimerInit

	If $iSW_Enable Then																															; If-Abfrage: Ist Star Wars an?

		$iSW_ScrollPos -= $iSW_ScrollSpeed																										; Variable definieren
		
		If $iSW_ScrollPos < $iSW_ScrollLeft Then $iSW_ScrollPos = $iSW_ScrollRight + ($iGUI_Width - ($iScrollerXPos * 2))						; If-Abfrage: Ist der Scroller links raus, dann rechts wieder starten

		_GDIPlus_GraphicsClear ($hST_Context, 0xFF00FF00)																						; GDIPlus: Objekt Löscht ein Grafik-Objekt auf eine angegebene Farbe
		$aST_Rectf = _GDIPlus_RectFCreate ($iSW_ScrollPos, 0, 0, $aLabelHeight[$iScroller])														; Variable definieren: GDIPlus Struktur erstellen
		_GDIPlus_GraphicsDrawStringEx ($hST_Context, $sSW_ScrollText, $hST_ScrollerFont, $aST_Rectf, $hST_Format, $hST_Brush)					; GDIPlus: String zeichnen
		_GDIPlus_GraphicsDrawImageRect ($hST_Graphics, $hST_Bitmap, 0, 0, $iGUI_Width - ($iScrollerXPos * 2), $aLabelHeight[$iScroller])		; GDIPlus: Zeichnet ein Bild an einer bestimmten Stelle

;~ 		$sCW_Text = "ScrollWidth: " & $iST_ScrollWidth & " - ScrollPos: " & $iSW_ScrollPos														; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

	ElseIf Not $iSW_Enable And $iTextSlider Then																								; ElseIf-Abfrage: Ist Star Wars aus, aber der TextSlider an?
		
		$iSW_ScrollPos = $iSW_ScrollRight + $iSW_ScrollCenter																					; Variable definieren: Star Wars Scroller Startposition zurück setzen

	EndIf																																		; Ende der If-Abfrage: Ist Star Wars an?

	$aSW_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aSW_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

  	If $iDebugTimer Then $sCW_Text = "Elepsaed time within StarWarsScroller: " & TimerDiff ($iAdLibTimer)										; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: StarWarsScroller

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: _GuiCtrlSetFont
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func _GuiCtrlSetFont ($xControlID, $xSize, $xRotation = 0, $xWeight = 400, $xAttribute = 0, $xQuality = 2, $xFontname = "")						; Funktionsstart: _GuiCtrlSetFont

	If $xFontNew Then _WinAPI_DeleteObject($xFontNew)																							; Altes FontObjekt löschen, wenn True

	Local $xFontItalic    = BitAND ($xAttribute, 1)																								; Variablen initialisieren
	Local $xFontUnderline = BitAND ($xAttribute, 2)																								; Variablen initialisieren
	Local $xFontStrikeOut = BitAND ($xAttribute, 4)																								; Variablen initialisieren

	$xFontNew = _WinAPI_CreateFont($xSize, 0, $xRotation, 0, $xWeight, $xFontItalic, _															; Veränderten Font im Array ersellen (Teil 1)
								   $xFontUnderline, $xFontStrikeOut, -1, 0, 0, $xQuality, 0, $xFontname)										; Veränderten Font im Array ersellen (Teil 2)

	GUICtrlSendMsg($xControlID, 48, $xFontNew, 1)																								; Veränderten Font auf Label anwenden

EndFunc																																			; Funktionsende: _GuiCtrlSetFont

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: LoadBGImage
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func LoadBGImage()																																; Funktionsstart: LoadBGImage

	Select																																		; Select-Abfrage: Welcher Modus ist aktiv?
	
		Case Not $iSW_Enable																													; Case: Normal Modus aktiv?
		
			If $iBG_NormalActual <> $iBG_NormalNr Then GUICtrlSendMsg($hBackground, $STM_SETIMAGE, 0, $ah_ScrollLabel[$iBG_NormalNr])			; If-Abfrage: Ist das falsche Hintergrundbild noch aktiv?
	
		Case $iSW_Enable																														; Case: Star Wars Modus aktiv?
		
			If $iBG_StarWarsActual <> $iBG_StarWarsNr Then GUICtrlSendMsg($hBackground, $STM_SETIMAGE, 0, $ah_BG_StarWarsFile[$iBG_StarWarsNr])	; If-Abfrage: Ist das falsche Hintergrundbild noch aktiv?
	
	EndSelect																																	; Ende der Select-Abfrage: Welcher Modus ist aktiv?
	
	GUICtrlSetState ($hBackground, $GUI_DISABLE)																								; Bild in den Hintergrund packen
	GUICtrlSetState ($hScrollLabel, $GUI_SHOW)																									; Label wieder in der Vordergrund holen
	GUICtrlSetState ($hMessage[3], $GUI_SHOW)																									; Label wieder in der Vordergrund holen

	$iBG_NormalActual = $iBG_NormalNr																											; Variable definieren
	$iBG_StarWarsActual = $iBG_StarWarsNr																										; Variable definieren

EndFunc																																			; Funktionsende: LoadBGImage

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsImageToggleShow
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsImageToggleShow ($iSW_ChooseImage = False)																							; Funktionsstart: StarWarsImageToggleShow

	Local $sCW_Text																																; Variable initialisieren

	If $iSW_Enable Then																															; If-Abfrage: Ist der BLINK-Text geklickt worden?

;~ 		$sCW_Text = "ChooseImage: " & $iSW_ChooseImage																							; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

		If Not $iSW_ChooseImage Then																											; If-Abfrage: Ist Wert "True" wurde nichts übergeben

			$iSW_Image += 1																														; Variable definieren: Wert um 1 erhöhen
			If $iSW_Image > $iSW_ImagesMax Then $iSW_Image = 1																					; If-Abfrage: Ist der Wert zu hoch, wieder auf 1 setzen

		Else																																	; Else-Abfrage: Ist Wert "True" wurde nichts übergeben

			$iSW_Image = $iSW_ChooseImage																										; Variable definieren: Übergebenen Wert setzen
			$iSW_ChooseImage = False																											; Variable definieren: Fest auf "False" setzen

		EndIf																																	; Ende der If-Abfrage: Ist Wert "True" wurde nichts übergeben

		If $iSW_ImageActual <> $iSW_Image Then																									; If-Abfrage: Ist das aktuelle Bild gleich dem "neuen" Bild?

			GUICtrlSendMsg($hImageFile, $STM_SETIMAGE, 0, 0)																					; Bild aus Image-GUI löschen
			GUICtrlSendMsg($hImageFile, $STM_SETIMAGE, 0, $ah_SW_ImageFile[$iSW_Image])															; StarWars Bild wechseln
			$iSW_ImageActual = $iSW_Image																										; Variable definieren

		EndIf																																	; Ende der If-Abfrage: Ist das aktuelle Bild gleich dem "neuen" Bild?

	EndIf																																		; Ende der If-Abfrage: Ist der BLINK-Text geklickt worden?

EndFunc																																			; Funktionsende: StarWarsImageToggleShow

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsImageMove (_Timer_SetTimer)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsImageMove($hWnd, $iMsg, $iIDTimer, $iTime)																							; Funktionsstart: StarWarsImageMove

	Local $iAdLibTimer = TimerInit(), $sCW_Text																									; Lokale Variable definieren: AdLib TimerInit

	Local Static $SI_LoopSwitch = True, $SI_ScrollPos = 0, $SI_SinusPos = 0																		; Lokale Static Variablen initialisieren und definieren
	Local $SI_Len = $iGUI_Width / 10, $SI_ScrollPosStep = 4, $SI_LoopCounter, $pi = 3.14159265358979, $degToRad = $pi / 180						; Lokale Variablen initialisieren

	$SI_LoopCounter = 0																															; Variable definieren

	If $iTextSlider And $iSW_Enable Then																										; If-Abfrage: Bewegt sich der TextSlider und ist der Star Wars Modus aktiv?

		If $SI_LoopSwitch Then																													; If-Abfrage: Welcher DoLoop Modus ist aktiv? 
					
			$SI_ScrollPos += $SI_ScrollPosStep																									; Variable definieren
				
			If $aMoveGUIPos[1] <= $aSW_XPosDelay[2] And $aMoveGUIPos[1] >= -$aSW_XPosDelay[3] Then												; If-Abfrage: Ist der Wert zwschen $aSW_XPosDelay[2] und -$aSW_XPosDelay[3]

				$aMoveGUIPos[1] += $aSW_XPosDelay[1]																							; Variable definieren: Wert für X-Pos der Image-GUI normal vergrößern

			ElseIf $aMoveGUIPos[1] >= $aSW_XPosDelay[2] Or $aMoveGUIPos[1] <= -$aSW_XPosDelay[2] Then											; ElseIf-Abfrage: Ist der Wert größer, gleich $aSW_XPosDelay[2] oder kleiner, gleich -$aSW_XPosDelay[2]

				$aMoveGUIPos[1] += $aSW_XPosDelay[1] - $aSW_XPosDelay[4]																		; Variable definieren: Wert für X-Pos der Image-GUI geringer vergrößern

			EndIf																																; Ende der If-Abfrage: Ist der Wert zwschen 90 und -100

		ElseIf Not $SI_LoopSwitch Then																											; ElseIf-Abfrage: Welcher DoLoop Modus ist aktiv?
				
			$SI_ScrollPos -= $SI_ScrollPosStep																									; Variable definieren
			
			If $aMoveGUIPos[1] <= $aSW_XPosDelay[3] And $aMoveGUIPos[1] >= -$aSW_XPosDelay[2] Then												; If-Abfrage: Ist der Wert zwschen $aSW_XPosDelay[3] und -$aSW_XPosDelay[2]

				$aMoveGUIPos[1] -= $aSW_XPosDelay[1]																							; Variable definieren: Wert für X-Pos der Image-GUI normal verkleinern

			ElseIf $aMoveGUIPos[1] >= $aSW_XPosDelay[2] Or $aMoveGUIPos[1] <= -$aSW_XPosDelay[2] Then											; ElseIf-Abfrage: Ist der Wert größer, gleich $aSW_XPosDelay[2] oder kleiner, gleich -$aSW_XPosDelay[2]

				$aMoveGUIPos[1] -= $aSW_XPosDelay[1] - $aSW_XPosDelay[4]																		; Variable definieren: Wert für X-Pos der Image-GUI geringer verkleinern

			EndIf																																; Ende der If-Abfrage: Ist der Wert zwschen 100 und -90

		EndIf																																	; Ende der If-Abfrage: Welcher DoLoop Modus ist aktiv?

		If $SI_ScrollPos > $SI_Len Or $SI_ScrollPos < -$SI_Len Then 																			; If-Abfrage: Wechsel der Richtung
			
			$SI_LoopSwitch = Not $SI_LoopSwitch																									; Variable definieren	
			$SI_LoopCounter = 1																													; Variable definieren
		
		EndIf 																																	; Ende der If-Abfrage: Wechsel der Richtung

;~ 		$sCW_Text = "Aktuelle Schrittweite: " & $aMoveGUIPos[1]																					; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

		$aInfoFormPos = WinGetPos($hInfoFormGUI)																								; Position der Haupt-GUI ermitteln

		$aMoveGUIPos[3] = ($aInfoFormPos[0] + $aMoveGUIPos[2]) - $aMoveGUIPos[1]																; If-Abfrage: Variablen-Array definieren
		WinMove ($hImageGUI, "", $aMoveGUIPos[3], $aInfoFormPos[1] + $aMoveGUIPos[4])															; If-Abfrage: StarWars Bild bewegen

		If $iSW_ForceModify = 2 And $SI_LoopCounter = 1 Then $iSW_ForceMode = True																; If-Abfrage: Wurde die Taste + oder Num + gedrückt und die DO-Schleife ist ganz oben, dann StarWarsForce aktivieren

		If $iSW_ForceMode Then																													; If-Abfrage: Ist die StarWarsForce aktiviert
			
			$aMoveGUIPos[4] = (Sin ($SI_SinusPos * $degToRad) * 100) + $iImageYPos																; Y-Pos der Image-GUI dynamisch verändern
			$SI_SinusPos += 10																													; Variable definieren
			If $SI_SinusPos > 360 Then $SI_SinusPos = 0																							; If-Abfrage: Variable definieren:

		EndIf																																	; Ende der If-Abfrage: Ist die StarWarsForce aktiviert

		If $iSW_ForceModify = 1 And $aMoveGUIPos[4] > $iImageYPos - $aSW_XPosDelay[1] _															; If-Abfrage: Wurde die Taste - oder Num - gedrückt und die Image-GUI steht ungefähr auf der Default Y-Pos, dann StarWarsForce deaktivieren (Teil 1)
							   And $aMoveGUIPos[4] < $iImageYPos + $aSW_XPosDelay[1] Then														; If-Abfrage: Wurde die Taste - oder Num - gedrückt und die Image-GUI steht ungefähr auf der Default Y-Pos, dann StarWarsForce deaktivieren (Teil 2)

			$aMoveGUIPos[4] = $iImageYPos																										; Variable definieren: X-Pos der Image-GUI wieder auf Default setzen
			$iSW_ForceMode = False																												; Variable definieren: $iSW_ForceMode fest auf "False" setzen
			$iSW_ForceModify = 0																												; Variable definieren: $iSW_ForceModify auf "0" setzen

		EndIf																																	; Ende der If-Abfrage: Wurde die Taste - oder Num - gedrückt und die Image-GUI steht ungefähr auf der Default Y-Pos, dann StarWarsForce deaktivieren

	EndIf																																		; Ende der If-Abfrage: Bewegt sich der TextSlider?

;~ 	$sCW_Text = "FY: " & $iSW_ForceModify & " - LC: " & $SI_LoopCounter & " - FM: " & $iSW_ForceMode & " - MG: " & $aMoveGUIPos[4]				; Variable definieren: $sCW_Text
;~ 	_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																								; Funktion anspringen: Ausgabe Console

	$aSI_CPS[0] += 1																															; Variable definieren: Cycles per Second (Aktuell)
	$aSI_CPS[1] += 1																															; Variable definieren: Cycles per Second (Durchschnitt)

  	If $iDebugTimer Then $sCW_Text = "Elepsaed time within StarWarsImageMove: " & TimerDiff ($iAdLibTimer)										; Variable definieren: $sCW_Text
	If $iDebugTimer Then _ConsoleWrite (@ScriptLineNumber, $sCW_Text)																			; If-Abfrage: Funktion anspringen: Ausgabe Console

EndFunc																																			; Funktionsende: StarWarsImageMove

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsForceEnable
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsForceEnable()																														; Funktionsstart: StarWarsForceEnable

	If $iTextSlider And $iSW_Enable Then $iSW_ForceModify = 2																					; If-Abfrage: Variable definieren: StarWarsForceEnable

EndFunc																																			; Funktionsende: StarWarsForceEnable

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsForceDisable
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsForceDisable()																														; Funktionsstart: StarWarsForceDisable

	If $iTextSlider And $iSW_Enable Then $iSW_ForceModify = 1																					; If-Abfrage: Variable definieren: StarWarsForceEnable

EndFunc																																			; Funktionsende: StarWarsForceDisable

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Funktion: StarWarsEnable
; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Func StarWarsEnable()																															; Funktionsstart: StarWarsEnable

	Local $sCW_Text																																; Variable initialisieren

	$iSW_Enable = Not $iSW_Enable																												; Variable definieren: Wechsel zwischen "True" und "False"
	$iCT_SongManual = False																														; Variable definieren: Manuellen Song-Play wieder abschalten

	If BitAND (WinGetState ($hInfoFormGUI), 8) Then GUIPush()																					; If-Abfrage: Funktion anspringen: GUIPush

	If $iSW_Enable Then																															; If-Abfrage: Ist der FORCE-Text geklickt worden?

		$iBG_StarWarsNr = Random (1, $iBG_StarWarsMax, 1)																						; Variable definieren: Hintergrund im Star Wars Modus zufällig neu wählen
		$iBG_StarWarsActual = $iBG_StarWarsNr																									; Variable definieren
		GUICtrlSendMsg($hBackground, $STM_SETIMAGE, 0, $ah_BG_StarWarsFile[$iBG_StarWarsNr])													; Hintergrundbild laden
		GUICtrlSetState ($hBackground, $GUI_DISABLE)																							; Bild in den Hintergrund packen

;~ 		$sCW_Text = "StarWars BG: " & $iBG_StarWarsNr																							; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

		$iCT_SongNr = 0																															; Variable definieren: Fest auf 0 setzen

		$aInfoFormPos = WinGetPos($hInfoFormGUI)																								; Position der Haupt-GUI ermitteln
		$aMoveGUIPos[1] = $aMoveGUIPos[1]																										; Variablen-Array definieren: Schrittweite auf der X-Pos der Image-GUI
		$aMoveGUIPos[2] = ($iGUI_Width - $iImageGUI_Width) / 2																					; Variablen-Array definieren: festgelegte X-Pos der Image-GUI
		$aMoveGUIPos[3] = ($aInfoFormPos[0] + $aMoveGUIPos[2]) - $aMoveGUIPos[1]																; Variablen-Array definieren: errechnete X-Pos der Image-GUI
		$aMoveGUIPos[4] = $iImageYPos																											; Variablen-Array definieren: festgelegte Y-Pos der Image-GUI
		WinMove ($hImageGUI, "", $aMoveGUIPos[3], $aInfoFormPos[1] + $aMoveGUIPos[4])															; If-Abfrage: StarWars Bild entgegen des Scrollers bewegen

		StarWarsImageToggleShow()																												; Funktion anspringen: Starwars Bild laden

	ElseIf Not $iSW_Enable Then																													; ElseIf-Abfrage: Ist der FORCE-Text geklickt worden?

		$iBG_NormalNr = Random (1, $iBG_NormalMax, 1)																							; Variable definieren: Hintergrund im normalen Modus zufällig neu wählen
		$iBG_NormalActual = $iBG_NormalNr																										; Variable definieren
		GUICtrlSendMsg ($hBackground, $STM_SETIMAGE, 0, $ah_ScrollLabel[$iBG_NormalNr])															; Hintergrundbild laden
		GUICtrlSetState ($hBackground, $GUI_DISABLE)																							; Bild in den Hintergrund packen

;~ 		$sCW_Text = "Normalmode BG: " & $iBG_NormalNr																							; Variable definieren: $sCW_Text
;~ 		_ConsoleWrite (@ScriptLineNumber, $sCW_Text)																							; Funktion anspringen: Ausgabe Console

		$iCT_SongNr = Random (1, $iCT_SongsMax, 1)																								; Variable definieren: per Zufall das Lied auswählen

		$iSW_ForceMode = False																													; Variable definieren: $iSW_ForceMode fest auf "False" setzen
		$iSW_ForceModify = 0																													; Variable definieren: $iSW_ForceModify auf "0" setzen

	EndIf																																		; Ende der If-Abfrage: Ist der FORCE-Text geklickt worden?

	If BitAND (WinGetState ($hInfoFormGUI), 8) Then GUIPush()																					; If-Abfrage: Funktion anspringen: GUIPush

EndFunc																																			; Funktionsende: StarwarsEnable

; ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
